package com.engine.cube.cmd.app;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.api.formmode.cache.ModeFormFieldEncryptComInfo;
import com.cloudstore.dev.api.util.Util_TableMap;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.common.entity.EncryptFieldEntity;
import com.engine.core.interceptor.CommandContext;
import com.engine.cube.biz.CardFormHelper;
import com.engine.cube.biz.DetachHelper;
import com.engine.encrypt.biz.EncryptFieldConfigComInfo;
import com.engine.cube.util.AddSeclevelUtil;
import com.weaver.formmodel.util.StringHelper;
import weaver.conn.RecordSet;
import weaver.conn.constant.DBConstant;
import weaver.formmode.cache.StringCacheMap;
import weaver.formmode.excel.ExcelCacheUtil;
import weaver.formmode.excel.ExpExcelUtil;
import weaver.formmode.excel.ImpExcelServer;
import weaver.formmode.service.AppInfoService;
import weaver.formmode.service.FormInfoService;
import weaver.formmode.service.ModelInfoService;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.*;


public class GetBatchImportInfo extends AbstractCommonCommand<Map<String, Object>> {
	
	private static String hostaddr = "";

    public GetBatchImportInfo(Map<String, Object> params, User user) {
        this.params = params;
        this.user = user;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }
    
    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
		Map<String, Object> result = new HashMap<String,Object>();
		String modeid = Util.null2String(this.params.get("modeid"));
		boolean BatchImportRight = false;
		ModeRightInfo modeRightInfo = new ModeRightInfo();
		modeRightInfo.setModeId(Util.getIntValue(modeid));
		modeRightInfo.setUser(user);
		modeRightInfo.setType(4);
		BatchImportRight = modeRightInfo.checkUserRight(4);
		if (!BatchImportRight) {
			BatchImportRight = HrmUserVarify.checkUserRight("ModeSetting:All", user);
		}
		if(!BatchImportRight){
			result.put("status", false);
			result.put("errorCode","no-right");
			result.put("error",SystemEnv.getHtmlLabelName(2011,user.getLanguage()));//没有权限
			result.put("noRight", true);
			return result;
		}
    	String operation = Util.null2String(this.params.get("operation"));
		String customId = Util.null2String(this.params.get("customid"));
		String isSinglePage = Util.null2String(this.params.get("isSinglePage"));//单页模式用于前端用户导入
    	int sourcetype = 0;
    	if(!"1".equals(isSinglePage)){
    		sourcetype = 1;
    	}
    	
    	int modelId = Util.getIntValue(modeid);
    	int appId = Util.getIntValue(Util.null2String(this.params.get("appid")));//当前所选应用id
    	
    	ModelInfoService modelInfoService = new ModelInfoService();
    	AppInfoService appInfoService = new AppInfoService();
    	Map<String, Object> data = new HashMap<String, Object>();
    	if(modelId>0){
    		data = modelInfoService.getModelInfoById(modelId);
    	}	
    	if(modelId>0&&data.size()==0){
    		throw new RuntimeException("no data was found");
    	}
    	
    	int modetype = Util.getIntValue(Util.null2String(data.get("modetype")),0);
    	int formid = Util.getIntValue(Util.null2String(data.get("formid")),0);
    	String modename = Util.null2String(data.get("modename"));
    	if(modelId==0){
    		modetype = appId;
    	}
    	int tempId = modetype;
    	if(tempId==0){
    		tempId = appId;
    	}
    	String maintablename ="";
    	RecordSet recordSet = new RecordSet();
		recordSet.executeQuery("select tablename from workflow_bill where id = ?",formid);
    	if(recordSet.next()){
			maintablename = recordSet.getString("tablename");
		}
    	String userRightStr = "ModeSetting:All";
    	Map<String, Object> appInfo = appInfoService.getAppInfoById(tempId);
    	boolean isUseFmManageDetach=DetachHelper.modeDetachIsOpen();
    	int subCompanyId = Util.getIntValue(Util.null2String(data.get("subCompanyId")),-1);
    	if(subCompanyId==-1){
    		subCompanyId = Util.getIntValue(Util.null2String(appInfo.get("subcompanyid")),-1);
    	}
    	int operatelevel = DetachHelper.getUserDeatchOperateLevel(user, subCompanyId, userRightStr);
		//判断模块是否开启分级保护
		AddSeclevelUtil addSeclevelUtil = new AddSeclevelUtil();
		boolean isOpenClassprotect = false;
		Map<String, Object> params = new HashMap<>();
		params.put("modeid", modeid);
		isOpenClassprotect = addSeclevelUtil.modeOpenClassProtect(params);
    	String fmdetachable = isUseFmManageDetach?"1":"0";
    	if(operation.equals("getImpStatus")){
    		JSONObject impStatus = new JSONObject();
    		String tempkey = Util.null2String(this.params.get("tempkey"));
    		String key = user.getUID()+"_"+modeid+"_"+tempkey;
    		Object obj = ExpExcelUtil.getObject("modeimp_"+key);
    		Map cacheMap = null;
    		if(obj!=null){
    			cacheMap = (Map) obj;
    		}
			int step = 0;
    		if(cacheMap!=null&&cacheMap.containsKey("msg")){
    			int s = 1;
    			String msg = Util.null2String(cacheMap.get("msg"));
    			String status = Util.null2String(cacheMap.get("status"));
    			step = Util.getIntValue(Util.null2String(cacheMap.get("step")));
    			String impaddr = Util.null2String(cacheMap.get("impaddr"));
    			String starttimeStr = Util.null2String(cacheMap.get("starttime"));
    			String endtimeStr = Util.null2String(cacheMap.get("endtime"));
    			String searchid = Util.null2String(cacheMap.get("searchid"));
				String errorflag = Util.null2String(cacheMap.get("errorflag"));
    			if(!"".equals(starttimeStr)&&!"".equals(endtimeStr)){
    				long starttime = Long.parseLong(starttimeStr);
    				long endtime= Long.parseLong(endtimeStr);
    				if(starttime>endtime){//还未结束
    					ImpExcelServer.putMessage("status", key,  "0");
    					if(step==6){
    						step = 0;
    						msg = "";
    						s = 0;
    						ImpExcelServer.putMessage("step", key,  "0");
    					}
    				}
    			}
    			String errmsg = "";
    			String time = "";
    			if(status.equals("-1")){
    				errmsg = Util.null2String(cacheMap.get("errmsg"));
    				time = Util.null2String(cacheMap.get("time"));
    				if(!StringHelper.isEmpty(errmsg)){
    					errmsg = errmsg.replace("\\n","<br />");
    				}
    			}
    			impStatus.put("s",s);
    			impStatus.put("msg",msg);
    			impStatus.put("status",status);
    			impStatus.put("errmsg",errmsg);
    			impStatus.put("time",time);
    			impStatus.put("step",step);
    			impStatus.put("impaddr", impaddr);
				impStatus.put("searchid", searchid);
				impStatus.put("errorflag", errorflag);
				impStatus.put("modeid", modeid);
    		}else{
    			impStatus.put("s",0);
    			impStatus.put("size",cacheMap==null?0:cacheMap.size());
    		}
    		hostaddr = ExcelCacheUtil.getHostaddr();
    		result.put("hostaddr", hostaddr);
    		result.put("impStatus", impStatus);
//    		try {
//				if(step>3){//主表数据执行后就删除临时表,序列删除，触发器删除
//					RecordSet rs = new RecordSet();
//					rs.execute("delete from  M_"+modeid+"_"+user.getUID());
//					rs.writeLog("GetBatchImportInfo-step="+step);
//					String dbType = rs.getDBType();
////					if(DBConstant.DB_TYPE_ORACLE.equals(dbType)){
////					rs.execute("DROP SEQUENCE M_"+modeid+"_"+user.getUID()+"_id");
////					rs.execute("DROP TRIGGER M_"+modeid+"_"+user.getUID()+"_Trigger");
////					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
			return result;
    	}else if(operation.equals("stopImport")){
    		String tempkey = Util.null2String(this.params.get("tempkey"));
    		String key = user.getUID()+"_"+modeid+"_"+tempkey+"_cancel";
    		StringCacheMap.put(key, key);
    		hostaddr = ExcelCacheUtil.getHostaddr();
    		result.put("hostaddr", hostaddr);
			return result;
    	}else if(operation.equals("getBatchImportLogList")){
    		String startdate = Util.null2String(this.params.get("startdate"));
    		String enddate = Util.null2String(this.params.get("enddate"));
    		String operator = Util.null2String(this.params.get("operator"));
    		String operatetype = Util.null2String(this.params.get("operatetype"));
    		
    		String SqlWhere = " where a.modeid='"+modeid+"' " ;
    		if(!startdate.isEmpty()){
    			SqlWhere += " and optdatetime >= '"+startdate+" 00:00:00'";
    		}
    		if(!enddate.isEmpty()){
    			SqlWhere += " and optdatetime <= '"+enddate+" 23:59:59 '";
    		}
    		if(!operator.isEmpty()){
    			SqlWhere += " and operator = '"+operator+"'";
    		}
    		if(!operatetype.isEmpty()){
    			SqlWhere += " and operatetype = '"+operatetype+"'";
    		}
    		
    		String perpage = "10";
    		String backFields = " a.id,a.id optid,a.modeid,a.operatetype,a.ipaddress,a.operator,a.optdatetime,a.addrow,a.updaterow,a.delrow,a.failurerow,a.adddetailrow,a.deldetailrow,a.backupremark,a.backindex";
    		String sqlFrom = " from mode_batchimp_log a ";
    		String pageUid = "modeList_12345678";
    		String orderby = " a.optdatetime desc ";
    		String tableString=""+
    			"<table  pagesize=\""+perpage+"\" tabletype=\"none\"  pageId=\""+pageUid+"\" pageUid=\""+ pageUid+ "\"  >"+
    				"<sql backfields=\""+backFields+"\" sqlform=\""+sqlFrom+"\" sqlorderby=\""+orderby+"\"  sqlprimarykey=\"a.id\" sqlsortway=\"desc\" sqldistinct=\"true\" sqlwhere=\""+Util.toHtmlForSplitPage(SqlWhere)+"\"/>"+
    					"<head>"+           
    						//操作人    
    						"<col width=\"15%\"  text=\""+SystemEnv.getHtmlLabelName(17482,user.getLanguage())+"\" column=\"operator\" orderkey=\"operator\"  otherpara=\"operator+"+user.getLanguage()+"\" transmethod=\"weaver.formmode.service.LogService.getLogNameByBatch\" />"+
    						//操作类型
    						"<col width=\"12%\"  text=\""+SystemEnv.getHtmlLabelName(15503,user.getLanguage())+"\" column=\"operatetype\" orderkey=\"operatetype\" otherpara=\"operatetype+"+user.getLanguage()+"\" transmethod=\"weaver.formmode.service.LogService.getLogNameByBatch\"  />"+
    						"<col width=\"12%\"  text=\"IP\" column=\"ipaddress\"    />"+
    						//操作日期
    						"<col width=\"20%\"  text=\""+SystemEnv.getHtmlLabelName(21663,user.getLanguage())+"\" column=\"optdatetime\"  />"+
    						//增加
    						"<col width=\"8%\"  text=\""+SystemEnv.getHtmlLabelName(456,user.getLanguage())+"\" column=\"addrow\"    />"+
    						//删除
    						"<col width=\"8%\"  text=\""+SystemEnv.getHtmlLabelName(17744,user.getLanguage())+"\" column=\"updaterow\"    />"+
    						//更新
    						"<col width=\"8%\"  text=\""+SystemEnv.getHtmlLabelName(125426,user.getLanguage())+"\" column=\"delrow\"    />"+
							//失败
							"<col width=\"8%\"  text=\""+SystemEnv.getHtmlLabelName(388508,user.getLanguage())+"\" column=\"failurerow\" />"+
    						//增加明细
    						"<col width=\"12%\"  text=\""+SystemEnv.getHtmlLabelName(129856,user.getLanguage())+"\" column=\"adddetailrow\"    />"+
    						//删除明细
    						"<col width=\"12%\"  text=\""+SystemEnv.getHtmlLabelName(129857,user.getLanguage())+"\" column=\"deldetailrow\"    />"+
    						"<col width=\"0%\" hide=\"true\"   text=\"backindex\" column=\"backindex\"     />";
    			if (operatelevel>=2) {//如果拥有完全控制权限
    				//下载导入的文件
					tableString+="<col width=\"12%\"  text=\""+SystemEnv.getHtmlLabelName(539084,user.getLanguage())+"\" column=\"optid\" otherpara=\""+user.getLanguage()+"\" transmethod=\"weaver.formmode.service.LogService.getBatchImportOperate\"/>";
					//备注
    				tableString+="<col width=\"30%\"  text=\""+SystemEnv.getHtmlLabelName(454,user.getLanguage())+"\" column=\"backupremark\"    />";
				}
    			tableString+=			
    						"</head>"+
    			"</table>";
    	    	Map<String, Object> apidatas = new HashMap<String, Object>();
    			String sessionkey = pageUid + "_" + Util.getEncrypt(Util.getRandom());
    	    	Util_TableMap.setVal(sessionkey, tableString);
    	    	apidatas.put("sessionkey", sessionkey);
    	    	return apidatas;
    	}
    	if("getTemplate".equals(operation)){
    		JSONArray templateFields = new JSONArray();
    		FormInfoService formInfoService = new FormInfoService();
    		formInfoService.setUser(user);
    		net.sf.json.JSONObject resultObj = formInfoService.getAllFieldByImport(Util.getIntValue(modeid),formid);
    		
    		String maintable1 =  resultObj.getString("maintable");
			net.sf.json.JSONArray tables =  resultObj.getJSONArray("tables");
			for(int i=0;i<tables.size();i++){
				String table = tables.getString(i);
				String tablename = table.replace(maintable1, "");
				String tablenamelabel = "";
				if("".equals(tablename)){
					tablename = SystemEnv.getHtmlLabelName(21778,user.getLanguage())+"("+maintable1+")";
					tablenamelabel = SystemEnv.getHtmlLabelName(21778,user.getLanguage());
				}else{
					tablename = table.replace(maintable1+"_dt", "");
					tablenamelabel = SystemEnv.getHtmlLabelName(17463,user.getLanguage())+tablename;
				}
				JSONObject tableObj = new JSONObject();
				tableObj.put("index", i);
				templateFields.add(tableObj);
				JSONArray fieldArray = new JSONArray();
				tableObj.put("tablenamelabel", tablenamelabel);
				tableObj.put("tablename", table);
				tableObj.put("fieldArray", fieldArray);
				net.sf.json.JSONArray tabledata = resultObj.getJSONArray(table);
				for (int j = 0; j < tabledata.size(); j++) {
					net.sf.json.JSONObject JSONObject = tabledata.getJSONObject(j);
					String fieldid = JSONObject.getString("fieldid");
					String fieldname = JSONObject.getString("fieldname");
//					if(isOpenClassprotect){
//						if("seclevel".equals(fieldname.toLowerCase())){
//							continue;
//						}
//					}
					String fieldlabelname = JSONObject.getString("fieldlabelname");
					String ischeck = JSONObject.getString("ischeck");
					String dsporder = JSONObject.getString("dsporder");
				
					JSONObject fieldObj = new JSONObject();
					fieldArray.add(fieldObj);
					fieldObj.put("key", fieldid);
					fieldObj.put("fieldid", fieldid);
					fieldObj.put("fieldname", fieldname);
					fieldObj.put("fieldlabelname", fieldlabelname);
					fieldObj.put("ischeck", ischeck);
					fieldObj.put("dsporder", dsporder);
				}
			}
			result.put("templateFields", templateFields);
			result.put("fmdetachable", fmdetachable);
			result.put("operatelevel", operatelevel);
			return result;
    	}else if("getFieldTrans".equals(operation)){//字段设置
    		JSONArray templateFields = this.getFieldTrans(modeid,formid);
			result.put("templateFields", templateFields);
			result.put("fmdetachable", fmdetachable);
			result.put("operatelevel", operatelevel);
			return result;
    	}else if("getBatchImportValidate".equals(operation)){
    		JSONObject batchImportValidate = new JSONObject();
    		   
    		RecordSet rs = new RecordSet();
    		RecordSet rs2 = new  RecordSet();
    		RecordSet RecordSet = new  RecordSet();
    		int validateid = Util.getIntValue(Util.null2String(this.params.get("validateid")));
    		String note = "";
    		if (validateid>0) {
    			String sql = "select note from mode_excelField where id="+validateid;
    			RecordSet.execute(sql);
    			if (RecordSet.next()) {
    				note = RecordSet.getString("note");
    			}
    		}
    		batchImportValidate.put("note", note);
    		
    		String sqlwhere = " and modeid="+StringHelper.empty2Null(modeid)+" and formid="+formid+" and ( fieldid  in ('-1000','-1001','-1002') or exists (select 1 from  workflow_billfield b where b.billid="+formid+" and b.id=a.fieldid) )";
			String sql2 = "select a.fieldid from mode_import_template a where 1=1 "+sqlwhere+"  order by a.dsporder,a.fieldid ";
			rs2.execute(sql2);//设置的字段
			int count = rs2.getCounts();
			sqlwhere = "";
			if(count>0){
				sqlwhere = " and exists (select 1 from  mode_import_template c where c.fieldid=a.id and c.modeid="+StringHelper.empty2Null(modeid)+" and c.formid="+formid+" )";	
			}
			
			//----------------选择框字段--------------------
			String sql = "";
			if(count>0){
				sql = "select * from (select a.id,a.viewtype,a.detailtable,b.indexdesc,a.fieldname from workflow_billfield a, htmllabelindex b "
						+ " where a.billid="+formid+" and fieldhtmltype=5 and type<>2  and b.id=a.fieldlabel "+sqlwhere+") t";
			}else{
				sql="select * from (select a.id,a.viewtype,a.detailtable,b.indexdesc ,c.needExcel,a.fieldname  from workflow_billfield a, htmllabelindex b, ModeFormFieldExtend c where c.needExcel = 1 and a.billid=c.formId "
			    	     +"and a.id=c.fieldId and a.billid="+formid+" and fieldhtmltype=5 and type<>2  and b.id=a.fieldlabel "
			    	     + " union "
			    	     + " select a.id,a.viewtype,a.detailtable,c.indexdesc,1 as needExcel, a.fieldname from workflow_billfield a ,HtmlLabelindex c where "
			    	     +"a.billid="+formid+" and c.id=a.fieldlabel and fieldhtmltype=5 and type<>2  and not exists (select 1 from ModeFormFieldExtend b where b.formid=a.billid and b.formid="+formid+" and b.fieldId=a.id)"
			    	     		+ ") t";
			}
			sql += " ORDER BY viewtype,detailtable,id ";
			JSONArray selectFields = new JSONArray();
			batchImportValidate.put("selectFields", selectFields);
			rs.execute(sql);
			while(rs.next()){
				JSONObject temp = new JSONObject();
				String fieldid = rs.getString("id");
				String fieldlabel = rs.getString("indexdesc");
				String detailtable = rs.getString("detailtable");
				String fieldname = rs.getString("fieldname");
				if(isOpenClassprotect){
					if("seclevel".equals(fieldname.toLowerCase())){
						continue;
					}
				}
				if(!detailtable.equals("")){
					fieldlabel = fieldlabel + "("+ SystemEnv.getHtmlLabelName(126218, user.getLanguage())+CardFormHelper.getNumOfDetailTableName(detailtable)+")";
				}
				if(StringHelper.isEmpty(detailtable)){
					detailtable = "maintable";
				}
				temp.put("key",fieldid);
				temp.put("showname",fieldlabel);
				temp.put("detailtable",detailtable);
				selectFields.add(temp);
			}
			
			
			//选择项目
			JSONObject selectOption = new JSONObject();
			batchImportValidate.put("selectOption", selectOption);
			sql = "select a.fieldid,a.selectvalue,a.selectname  from workflow_SelectItem a,workflow_billfield b "
			  		+ " where a.fieldid=b.id AND b.fieldhtmltype=5 AND b.billid="+formid+" ORDER BY b.viewtype,a.fieldid,a.listorder";
			 rs.execute(sql);
			 while(rs.next()){
				  String fieldid = rs.getString("fieldid");
				  String selectvalue = rs.getString("selectvalue");
				  String selectname = rs.getString("selectname");
				  JSONArray options = null;
				  if(selectOption.containsKey(fieldid)){
					  options = selectOption.getJSONArray(fieldid);
				  }else{
					  options = new JSONArray();
					  selectOption.put(fieldid, options);
				  }
				  JSONObject obj = new JSONObject();
				  obj.put("key", selectvalue);
				  obj.put("showname", selectname);
				  options.add(obj);
			 }
			 
			 //-------已经设置的列表------------
			 JSONArray validateFieldDetail = new JSONArray();
			 batchImportValidate.put("validateFieldDetail", validateFieldDetail);
		    if(validateid>0){
		    	sql = "select * from mode_excelFieldDetail where mainid="+validateid;
		    	if(count==0){
					sql+=" and (selectids in(select a.id from workflow_billfield a, htmllabelindex b, ModeFormFieldExtend c where c.needExcel = 1 and a.billid=c.formId "
			    	     +"and a.id=c.fieldId and a.billid="+formid+" and fieldhtmltype=5 and b.id=a.fieldlabel union select a.id from workflow_billfield a ,HtmlLabelindex c where "
			    	     +"a.billid="+formid+" and c.id=a.fieldlabel and fieldhtmltype=5 and not exists (select 1 from ModeFormFieldExtend b where b.formid=a.billid and b.formid="+formid+" and b.fieldId=a.id) )"
			    	     		+ " or (selectids is null or selectids='')) ";
				}
		    	sql += " order by id ";
		    	RecordSet.execute(sql);
		    	while(RecordSet.next()){
		    		String id = RecordSet.getString("id");
		    		String fieldid = RecordSet.getString("fieldid");
		            String selectid = Util.null2String(RecordSet.getString("selectids"));
		            String selectvalue = Util.null2String(RecordSet.getString("selectvalue"));
		            
		            JSONObject obj = new JSONObject();
		            obj.put("key", id);
		            obj.put("selectid", selectid);
		            obj.put("selectvalue", selectvalue);
		            obj.put("fieldid", fieldid);
		            validateFieldDetail.add(obj);
		    	}
		    }
		    
		    //如果没有数据默认添加一行
		    if(validateFieldDetail.size()==0){
		    	JSONObject obj = new JSONObject();
	            obj.put("key", "new_"+new Date().getTime());
	            obj.put("selectid", "");
	            obj.put("selectvalue", "");
	            obj.put("fieldid", "");
	            validateFieldDetail.add(obj);
		    }
		    
		    //----------------每个表的字段-----------------------
		    JSONObject tableFields = new JSONObject();
		    batchImportValidate.put("tableFields", tableFields);

			List<String[]>list=new ArrayList<String[]>();
			String selectid = "";

			String fieldsql = "";
			if(count==0){
				fieldsql = "select b.id,b.detailtable,c.indexdesc from  htmllabelindex c,workflow_billfield b left join ModeFormFieldExtend a "
						+ " on b.id=a.fieldId where  (needExcel !=0 or needExcel is null) and c.id=b.fieldlabel and b.billid="+formid;
			}else{
				fieldsql = "select b.*,c.indexdesc from  htmllabelindex c,workflow_billfield b  join mode_import_template a "
						+ " on b.id=a.fieldId and modeid='"+modeid+"' and formid='"+formid+"' where  c.id=b.fieldlabel and b.billid="+formid;
			}
			rs.executeQuery(fieldsql);
			List tableList = new ArrayList();
			while(rs.next()){
				////QC 364486 表单建模，设置为多语言，批量导入，导入必填字段，选择必填字段，乱码
				String indexdesc =Util.formatMultiLang(Util.null2String(rs.getString("indexdesc")), user.getLanguage()+"");
				String fieldid = Util.null2String(rs.getString("id"));
				String detailtable = Util.null2String(rs.getString("detailtable"));
				if(!detailtable.equals("")){
					indexdesc += "("+ SystemEnv.getHtmlLabelName(126218, user.getLanguage())  +CardFormHelper.getNumOfDetailTableName(detailtable)+")";
				}
				if(StringHelper.isEmpty(detailtable)){
					detailtable = "maintable";
				}
				JSONArray fieldids = null;
				if(tableFields.containsKey(detailtable)){
					fieldids = tableFields.getJSONArray(detailtable);
				}else{
					fieldids = new JSONArray();
					tableFields.put(detailtable,fieldids);
					tableList.add(detailtable);
				}
				JSONObject obj = new JSONObject();
	            obj.put("key", fieldid);
	            obj.put("showname", indexdesc);
	            
				fieldids.add(obj);
			}
			batchImportValidate.put("tableList",tableList);
    		result.put("batchImportValidate", batchImportValidate);
			result.put("fmdetachable", fmdetachable);
			result.put("operatelevel", operatelevel);
			return result;
    	}else if(operation.equals("checkImp")){
    		JSONObject jsonObj = ExpExcelUtil.checkCanImpExcel(user,modeid);
    		result.putAll(jsonObj);
			result.put("fmdetachable", fmdetachable);
			result.put("operatelevel", operatelevel);
			return result;
    	}else{
    		//-----获取基本信息
    		RecordSet rs = new RecordSet();
    		String needfav = "";
    		String needhelp = "";
    		
    		int rightLevel = -1;//无权限
    		
    		ModeRightInfo ModeRightInfo = new ModeRightInfo();
    		int type = 4;//批量导入权限
    		boolean isRight = false;
    		boolean isALLRight = false;
    		if (type == 4) {//监控权限判断
    			ModeRightInfo.setModeId(modelId);
    			ModeRightInfo.setType(type);
    			ModeRightInfo.setUser(user);
    			isRight = ModeRightInfo.checkUserRight(type);
    			if (!isRight) {
    				isALLRight = HrmUserVarify.checkUserRight(userRightStr, user);
    				if (!isALLRight) {
    					result.put("isRight", false);
    					result.put("rightLevel", -1);
    					result.put("fmdetachable", fmdetachable);
    					result.put("operatelevel", operatelevel);
    					
    					JSONObject batchImportInfo = new JSONObject();
    		    		batchImportInfo.put("modename", modename);
    		    		batchImportInfo.put("isRight", isRight);
    		    		batchImportInfo.put("formid", formid);
    		    		batchImportInfo.put("modeid", modeid);
    		    		result.put("batchImportInfo", batchImportInfo);
    		    		
    					return result;
    				}
    			}
    		}
    		
    		
    		List<Integer> importTypes = ModeRightInfo.checkUserImportType();
    		/*if (importTypes.size() == 0) {
    			if (isALLRight) {
    				importTypes.add(0);
    			}
    		}*/
    		
    		JSONArray importTypeOption = new JSONArray();
    		//根据后台设置的导入类型 这里做一个限制 
    		if ( importTypes.contains(1) || user.getUID()==1 ||isALLRight) {
    			JSONObject obj = new JSONObject();
	            obj.put("key", "1");
	            obj.put("showname",  SystemEnv.getHtmlLabelName(31259, user.getLanguage()));
    			importTypeOption.add(obj);
    		}
    		if (importTypes.contains(3) || user.getUID()==1  || isALLRight) {
    			JSONObject obj = new JSONObject();
	            obj.put("key", "3");
	            obj.put("showname",  SystemEnv.getHtmlLabelName(17744, user.getLanguage()));
    			importTypeOption.add(obj);
    		}
			if ( importTypes.contains(2)) {
				JSONObject obj = new JSONObject();
				obj.put("key", "2");
				obj.put("showname",  SystemEnv.getHtmlLabelName(517042, user.getLanguage()));
				importTypeOption.add(obj);
			}
    		
    		
    		//--------------
    		
    		String sql = "";
    		String interfacepath = "";
    		String fieldtranspath = "";
    		String importorder = "";
    		String isuse = "";
    		String validateid = "";
    		String keyfield = "";
    		int fieldDetailCount = 0;
    		String templateTitle = "";
    		String fieldtransTitle = "";
    		int isHaveTemplate = 0;
    		boolean isHaveFieldtrans=false;//是否存在导入转换接口
			if (modelId>0) {
				String templateSql = "select 1 from mode_import_template a where modeid=" + modeid + " and formid=" + formid + " and (exists(select 1 from workflow_billfield b where b.billid=" + formid + " and b.id=a.fieldid) or  a.fieldid in(-1000,-1001,-1002)) ";
				rs.execute(templateSql);
				if (rs.getCounts() > 0) {
					isHaveTemplate = 1;
				}
			}
    		//获取接口路径等信息
    		sql = "select * from mode_DataBatchImport where modeid=" + modeid;
    		rs.execute(sql);
    		if (rs.next()) {
    			interfacepath = rs.getString("interfacepath");
    			keyfield = rs.getString("keyfield");
    			fieldtranspath = rs.getString("fieldtranspath");
    			importorder = rs.getString("importorder");
    			isuse = rs.getString("isuse");
    			validateid = Util.null2String(rs.getString("validateid"));
    			if (!validateid.equals("")) {
    				sql = "select COUNT(a.id) as num from mode_excelFieldDetail a,mode_excelField b where a.mainid=b.id and b.modeid=" + modeid;
    				rs.execute(sql);
    				if (rs.next()) {
    					fieldDetailCount = rs.getInt("num");
    				}
    			}
    		}
    		
    		
    		if (sourcetype == 1 && operatelevel > 0) {
    			if(isHaveTemplate==1){//编辑模板
    				templateTitle = SystemEnv.getHtmlLabelName(28052, user.getLanguage());
    			}else{//设置模板
    				templateTitle = SystemEnv.getHtmlLabelName(503155, user.getLanguage());
    			}
    			if(isHaveFieldtrans){//编辑字段
    				fieldtransTitle = SystemEnv.getHtmlLabelName(15449, user.getLanguage());
    			}else{//设置字段
    				fieldtransTitle = SystemEnv.getHtmlLabelName(504193, user.getLanguage());
    			}
    		}
    		
    		JSONArray keyFieldOption = new JSONArray();
    		JSONObject obj = new JSONObject();
            obj.put("key", "");
            obj.put("showname",  "");
    		keyFieldOption.add(obj);
    		if (importTypes.size() == 0 || importTypes.contains(3) || importTypes.contains(0)|| user.getUID()==1  || isALLRight) {
    			String sql1 = "";
    			if(isHaveTemplate==1){
    				sql1 = " select 1 from  mode_import_template c where  c.fieldid=-1000 and c.modeid="+modeid+" and c.formid="+formid+" ";
    			}else{
    				sql1 = "select 1 from ModeFormFieldExtend where fieldid=-1000 and needExcel=1 and formid="+formid+" ";
    			}
    			rs.execute(sql1);
    			if(rs.getCounts()>0){//显示数据id时，才显示此选项
    				obj = new JSONObject();
    	            obj.put("key", "dataid");
    	            obj.put("showname",  SystemEnv.getHtmlLabelName(81287, user.getLanguage()));
    				keyFieldOption.add(obj);
    			}
    		}
    		
    		String sqlwhere = "";
    		if(isHaveTemplate==1){
    			sqlwhere = " and exists (select 1 from  mode_import_template c where c.fieldid=a.id and c.modeid="+modeid+" and c.formid="+formid+" )";
    			sql = "select a.id,a.fieldname,a.fieldlabel from workflow_billfield a where "
    					+ "billid="+formid +" and (fieldhtmltype<>2 and fieldhtmltype<>6 and fieldhtmltype<> 7) "
    					+sqlwhere+ " and viewtype=0 order by dsporder,id";
    		}else{
    			sql = "select a.id,a.fieldname,b.needExcel,a.fieldlabel from workflow_billfield a, ModeFormFieldExtend b where  b.formid=a.billid and "
    					+"b.formid="+formid+" and b.needExcel=1 and (fieldhtmltype<>2 and fieldhtmltype<>6 and fieldhtmltype<> 7) and viewtype=0 union "
    					+"select a.id,a.fieldname,1 as needExcel,a.fieldlabel from workflow_billfield a where a.billid="+formid+" "
    					+"and (fieldhtmltype<>2 and fieldhtmltype<>6 and fieldhtmltype<> 7) and a.viewtype=0  and not exists (select 1 from ModeFormFieldExtend b where b.formid=a.billid and b.formid="+formid+" and b.fieldId=a.id) ";
    		}
    		rs.execute(sql);
    		ModeFormFieldEncryptComInfo modeFormFieldEncryptComInfo=new ModeFormFieldEncryptComInfo();
    		while (rs.next()) {
    			String fieldid=rs.getString("id");
    			String fieldname = rs.getString("fieldname");
    			if(isOpenClassprotect){
					if("seclevel".equals(fieldname.toLowerCase())){
						continue;
					}
				}
				String labelname = SystemEnv.getHtmlLabelName(Util.getIntValue(rs.getString("fieldlabel")), user.getLanguage());
				EncryptFieldEntity encryptFieldEntity = new EncryptFieldConfigComInfo().getFieldEncryptConfig(maintablename, fieldname);
				String isencrypt = modeFormFieldEncryptComInfo.getIsencrypt(fieldid);
				if(encryptFieldEntity != null && ("1".equals(encryptFieldEntity.getDesensitization()) || "1".equals(encryptFieldEntity.getIsEncrypt()))) {
					isencrypt = "1";//前端不能选择加密字段
				}
    			obj = new JSONObject();
                obj.put("key", fieldname);
                obj.put("showname",  labelname);
				obj.put("isencrypt", isencrypt );
    			keyFieldOption.add(obj);
    		}
    		
    		if( (operatelevel < 1 && !isRight)){
    			rightLevel = 0;//只读权限
    		}else if(operatelevel>=0){
    			rightLevel = operatelevel;
    		}
    		
    		JSONObject batchImportInfo = new JSONObject();
    		batchImportInfo.put("importTypeOption", importTypeOption);
    		batchImportInfo.put("modename", modename);
    		batchImportInfo.put("templateTitle", templateTitle);
    		batchImportInfo.put("fieldtransTitle", fieldtransTitle);
    		batchImportInfo.put("isHaveFieldtrans", isHaveFieldtrans);
    		batchImportInfo.put("fieldtranspath", fieldtranspath);
    		batchImportInfo.put("isRight", isRight);
    		batchImportInfo.put("importorder", importorder);
    		batchImportInfo.put("interfacepath", interfacepath);
    		batchImportInfo.put("isuse", isuse);
    		batchImportInfo.put("validateid", validateid);
    		batchImportInfo.put("fieldDetailCount", fieldDetailCount);
    		batchImportInfo.put("keyFieldOption", keyFieldOption);
    		batchImportInfo.put("excelid", "");
    		batchImportInfo.put("formid", formid);
    		batchImportInfo.put("isHaveTemplate", isHaveTemplate);
    		batchImportInfo.put("modeid", modeid);
			RecordSet appRs= new RecordSet();
			appRs.executeQuery("select * from HrmOrganizationShowSet");
			String applyToModel = "";          //是否全路径
			while (appRs.next()){
				applyToModel = Util.null2String(appRs.getString("applyToModel"));
			}
			String windowTitle = "";
			if(null != customId&& !customId.equals("")){
				RecordSet titileRs = new RecordSet();
				titileRs.executeQuery("select customname from mode_customsearch where id = ?",customId);
				if(titileRs.next()){
					windowTitle = Util.null2String(titileRs.getString("customname"));
				}
			}
    		JSONArray arr = new JSONArray();
    		if (!"".equals(keyfield)) {
    			String [] keyfields = keyfield.split("\\|");
    			for (int i = 0; i < keyfields.length; i++) {
    				arr.add( keyfields[i]);
    			}
			}
    		batchImportInfo.put("keyfield", arr);
    		
    		//qc656609获取应用图标信息
    		String geticonsql = "select icon,iconcolor,iconbg from modetreefield where id=(select modetype from modeinfo where id="+modeid+")";
    		JSONObject iconInfo = new JSONObject();
    		String icon = "";//图标
			String iconcolor = "";//图标颜色
			String iconbg = "";//图标背景颜色
    		rs.execute(geticonsql);
    		if(rs.next()){
    			icon = rs.getString("icon");
    			iconcolor = rs.getString("iconcolor");
    			iconbg = rs.getString("iconbg");
    		}
    		iconInfo.put("icon", icon);
    		iconInfo.put("iconcolor", iconcolor);
    		iconInfo.put("iconbg", iconbg);
    		
			result.put("windowTitle", windowTitle);
			result.put("applyToModel", applyToModel);
    		result.put("rightLevel", rightLevel);
    		result.put("isRight", isRight);
    		result.put("batchImportInfo", batchImportInfo);
    		result.put("modeid", modeid);
    		result.put("operatelevel", operatelevel);
    		result.put("fmdetachable", fmdetachable);
    		result.put("iconInfo", iconInfo);
    		return result;
    	}
    }

    /**
     * 获取导入转换接口字段设置
     * @param modeid
     * @param formid
     * @return
     */
	private JSONArray getFieldTrans(String modeid, int formid) {
		JSONArray array = new JSONArray();
		RecordSet rs = new RecordSet();
		String sql = "select fieldid from mode_import_fieldtrans a where modeid=? and formid=? and (exists(select 1 from workflow_billfield b where b.billid=? and b.id=a.fieldid) or  a.fieldid in(-1000,-1001,-1002)) ";
		rs.executeQuery(sql, modeid,formid,formid);
		List<String> fieldTrans = new ArrayList<String>();
		while (rs.next()) {
			String fieldid=Util.null2String(rs.getString("fieldid"));
			fieldTrans.add(fieldid);
		}
		List<String> tables = new ArrayList<String>();
		String maintablename="";
		sql="select * from (select 'main' tabletype,tablename,0 as orderid from workflow_bill where id=? union select 'detail' tabletype,tablename,orderid from Workflow_billdetailtable where billid=? ) t order by orderid";
		rs.executeQuery(sql, formid,formid);
		while (rs.next()) {
			String tablename=Util.null2String(rs.getString("tablename"));
			String tabletype=Util.null2String(rs.getString("tabletype"));
			if ("main".equals(tabletype)) {
				maintablename=tablename;
			}
			tables.add(tablename);
		}
		sql="select fieldid,w.fieldname,info.labelname fieldlabelname,w.detailtable,w.viewtype from mode_import_template t left join workflow_billfield w on w.id=t.fieldid left join htmllabelinfo info on info.indexid=w.fieldlabel and info.languageid=? where t.modeid=? and t.formid=? order by t.fieldid";
		rs.executeQuery(sql, user.getLanguage(),modeid,formid);
		if (rs.getCounts()<=0) {//如果没有设置字段,则以表达中的导入字段为准
			sql=" select fieldid ,'' fieldname,'' fieldlabelname,'' detailtable,0 viewtype from modeformfieldextend where formid=? and needexcel=1 and fieldid in (-1000,-1001,-1002) ";
			sql+=" union all select w.id fieldid,w.fieldname,info.labelname fieldlabelname,w.detailtable,w.viewtype from workflow_billfield w left join htmllabelinfo info on info.indexid=w.fieldlabel and info.languageid=? where billid=? and  w.fieldhtmltype not in (6,7) and id not in (select fieldid from modeformfieldextend where needexcel=0 and formid=?)";
			rs.executeQuery(sql,formid, user.getLanguage(),formid,formid);
		}
		Map<String, JSONArray> infomap = new HashMap<String, JSONArray>();
		while (rs.next()) {
			String fieldid = Util.null2String(rs.getString("fieldid"));
			String fieldname = Util.null2String(rs.getString("fieldname"));
			String fieldlabelname = Util.null2String(rs.getString("fieldlabelname"));
			String detailtable = Util.null2String(rs.getString("detailtable"));
			String viewtype = Util.null2String(rs.getString("viewtype"));
			String temptablename=maintablename;
			if ("1".equals(viewtype)) {//明细表
				temptablename=detailtable;
			}
			if ("-1000".equals(fieldid)) {//数据id
				fieldname="id";
				fieldlabelname=SystemEnv.getHtmlLabelName(81287,user.getLanguage());
			}else if ("-1001".equals(fieldid)) {
				fieldname="modedatacreater";
				fieldlabelname=SystemEnv.getHtmlLabelName(382643,user.getLanguage());
			}else if ("-1002".equals(fieldid)) {
				fieldname="modedatacreatedate";
				fieldlabelname=SystemEnv.getHtmlLabelName(126848,user.getLanguage());
			}
			JSONArray tablemap;
			if (infomap.containsKey(temptablename)) {
				tablemap=infomap.get(temptablename);
			}else {
				tablemap=new JSONArray();
				infomap.put(temptablename, tablemap);
			}
			JSONObject obj = new JSONObject();
			obj.put("fieldid", fieldid);
			obj.put("key", fieldid);
			obj.put("fieldlabelname", fieldlabelname);
			obj.put("fieldname", fieldname);
			obj.put("ischeck", fieldTrans.contains(fieldid)?"1":"0");
			tablemap.add(obj);
		}
		for (int i = 0; i < tables.size(); i++) {
			String tablename = tables.get(i);
			JSONObject tableObj = new JSONObject();
			String tablenamelabel = "";
			if(i==0){//主表
				tablenamelabel = SystemEnv.getHtmlLabelName(21778,user.getLanguage());
			}else{
				String index = tablename.replace(maintablename+"_dt", "");
				tablenamelabel = SystemEnv.getHtmlLabelName(17463,user.getLanguage())+index;
			}
			tableObj.put("index", i);
			tableObj.put("tablename", tablename);
			tableObj.put("tablenamelabel", tablenamelabel);
			JSONArray fieldArray = infomap.get(tablename);
			if (fieldArray==null) {
				fieldArray=new JSONArray();
			}
			tableObj.put("fieldArray", fieldArray);
			array.add(tableObj);
		}
		return array;
	}
    
    

}