package com.engine.hansang.job;

import c.u.d.c.gh;
import com.alibaba.fastjson.JSONObject;
import com.engine.kq.util.KQDurationCalculatorUtil;
import com.time.util.DateUtil;
import org.apache.tools.ant.types.selectors.modifiedselector.Cache;
import org.htmlparser.tags.TableRow;
import weaver.conn.RecordSet;
import weaver.conn.RecordSetTrans;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.*;

/**
 * 统计加班时间超过80%的人员信息
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2023/9/7
 */

public class CountOvertimeWorkersJob extends BaseCronJob {
    private static DecimalFormat df = new DecimalFormat("0.00");

    @Override
    public void execute() {
        Map<String, String> jbmap = new HashMap<>(1000);
        String date = DateUtil.getCurrentTime("yyyy-MM");
        String start = date + "-01";
        String end = getLastDayByMonth();

        Map<String, Object> flowData = getFlowOverTimeDataNew(start, end);

        RecordSet rs = new RecordSet();
        //1、查询当月的加班时长限制
        String sql = "select bm,gw,zjj,dyljjbcexs from uf_jbfjsp where dyljjbcexs is not null";
        rs.execute(sql);
        while (rs.next()) {
            String bm = Util.null2String(rs.getString("bm"));
            String gw = Util.null2String(rs.getString("gw"));
            String zjj = Util.null2String(rs.getString("zjj"));
            String dyljjbcexs = Util.null2String(rs.getString("dyljjbcexs"));
            String str = bm + "-" + gw + "-" + zjj;
            jbmap.put(str, dyljjbcexs);
        }

        String formmodeid = "";
        rs.execute("select k.id from modeinfo k inner join workflow_bill l on formid = l.id where l.tablename = 'uf_gwjbsxtz'");
        if (rs.next()) {
            formmodeid = Util.null2String(rs.getString("id"));
        }

        rs.execute("delete from uf_gwjbsxtz where yf = '" + date + "'");

        //2、获取全部人员信息,查询人员的加班时长总计（当月）
        sql = "select a.id,a.workcode,a.lastname,a.departmentid,a.jobtitle,a.managerid,b.field35 as zjj,b.field102 as xnfz,b.field36 as xzsx,c.field118 as cbzxmc from hrmresource a left join cus_fielddata b on a.id = b.id left join cus_fielddata c on a.id = c.id where b.scope = 'HrmCustomFieldByInfoType' and b.scopeid = '-1' and c.scope = 'HrmCustomFieldByInfoType' and c.scopeid = '3'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            String workcode = Util.null2String(rs.getString("workcode"));
            String lastname = Util.null2String(rs.getString("lastname"));
            String departmentid = Util.null2String(rs.getString("departmentid"));
            String jobtitle = Util.null2String(rs.getString("jobtitle"));
            String managerid = Util.null2String(rs.getString("managerid"));
            String zjj = Util.null2String(rs.getString("zjj"));
            String xnfz = Util.null2String(rs.getString("xnfz"));
            String xzsx = Util.null2String(rs.getString("xzsx"));
            String cbzxmc = Util.null2String(rs.getString("cbzxmc"));

            Map<String, String> deptm = getDepartmentManager(departmentid);
            String bmjl = Util.null2String(deptm.get("bmjl"));
            String bmzj = Util.null2String(deptm.get("bmzj"));
            String bmzg = Util.null2String(deptm.get("bmzg"));

            String limithour = Util.null2String(jbmap.get(departmentid + "-" + jobtitle + "-" + zjj));

            if ("".equals(limithour)) {
                continue;
            }

            //获取人员当月的加班总计（小时）
            String overHours = getOverTimeByUserId(id, flowData);

            BigDecimal a = new BigDecimal(overHours);
            BigDecimal b = new BigDecimal(limithour);
            BigDecimal c = a.divide(b, 2, RoundingMode.HALF_UP);
            String bl = c.toString();

            //更新数据到岗位加班上限台账建模表
            insertData(workcode, id, departmentid, jobtitle, xzsx, cbzxmc, xnfz, managerid, limithour, overHours, date, formmodeid, bl, bmjl, bmzj, bmzg);

        }
    }

    private Map<String, String> getDepartmentManager(String deptid) {
        Map<String, String> map = new HashMap<>(100);
        String bmjl = "0";
        String bmzj = "0";
        String bmzg = "0";
        String sql = "select bmjl,bmzj,bmzg from hrmdepartmentdefined where deptid = ?";
        RecordSet rs = new RecordSet();
        rs.executeQuery(sql, deptid);
        while (rs.next()) {
            bmjl = Util.null2String(rs.getString("bmjl"));
            bmzj = Util.null2String(rs.getString("bmzj"));
            bmzg = Util.null2String(rs.getString("bmzg"));
        }
        map.put("bmjl", bmjl);
        map.put("bmzj", bmzj);
        map.put("bmzg", bmzg);

        return map;
    }

    private void insertData(String gh, String xm, String bm, String gw, String xzzx, String cbzx, String xnfz, String zjld, String dyjbsx, String dyljjbsc, String yf, String formmodeid, String bl, String bmjl, String bmzj, String bmzg) {
        RecordSetTrans rst = new RecordSetTrans();

        String modedatacreater = "1";
        String modedatacreatertype = "0";

        String createdate = DateUtil.getCurrentTime("yyyy-MM-dd");
        String createtime = DateUtil.getCurrentTime("HH:mm:ss");

        String modeuuid = UUID.randomUUID().toString();
        rst.setAutoCommit(false);
        try {
            String sql = " insert into uf_gwjbsxtz(gh,xm,bm,gw,xzzx,cbzx,xnfz,zjld,dyjbsx,dyljjbsc,yf,bl,bmjl,bmzj,bmzg,formmodeid,modedatacreater,modedatacreatertype,modeuuid,modedatacreatedate,modedatacreatetime) " +
                    "values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            rst.executeUpdate(sql, gh, xm, bm, gw, xzzx, cbzx, xnfz, zjld, dyjbsx, dyljjbsc, yf, bl, bmjl, bmzj, bmzg, formmodeid, modedatacreater, modedatacreatertype, modeuuid, createdate, createtime);
        } catch (Exception e) {
            e.getMessage();
        }

        rst.commit();
        int dataId = getDataIdByUUID(modeuuid);
        ModeRightInfo modeRightInfo = new ModeRightInfo();
        modeRightInfo.editModeDataShare(1, Integer.parseInt(formmodeid), dataId);

    }

    /**
     * 根据uuid获取建模的数据id，常用于建模的权限重构
     *
     * @param uuid modeUuid
     * @return dataId
     */
    public static int getDataIdByUUID(String uuid) {
        RecordSet rs = new RecordSet();
        int dataid = -1;
        String sql = "select id uf_gwjbsxtz where modeuuid = ?";
        if (rs.executeQuery(sql, uuid) && rs.next()) {
            dataid = Util.getIntValue(rs.getString(1));
        }
        return dataid;
    }

    /**
     * 获取实际加班数据，包括流程，打卡生成的
     *
     * @return
     */
    public Map<String, Object> getFlowOverTimeDataNew(String start, String end) {
        Map<String, Object> datas = new HashMap<>();
        ;
        RecordSet rs = new RecordSet();
        String sql = "select resourceid,changeType, sum(cast(duration_min as decimal(18,4))) as val,paidLeaveEnable  from hrmresource a, kq_flow_overtime b  where a.id = b.resourceid and belongdate >='" + start + "' and belongdate <='" + end + "'   group by resourceid,changeType,paidLeaveEnable";
        rs.execute(sql);
        try {
            while (rs.next()) {
                String resourceid = rs.getString("resourceid");
                String paidLeaveEnable = rs.getString("paidLeaveEnable");
                int changeType = rs.getInt("changeType");//1-节假日、2-工作日、3-休息日
                double value = rs.getDouble("val") < 0 ? 0 : rs.getDouble("val");

                value = Util.getDoubleValue(KQDurationCalculatorUtil.getDurationRound(value / (60.0) + ""));

                String flowType = "";
                if (changeType == 1) {
                    flowType = "holidayOvertime";
                } else if (changeType == 2) {
                    flowType = "workingDayOvertime";
                } else if (changeType == 3) {
                    flowType = "restDayOvertime";
                }
                if ("1".equalsIgnoreCase(paidLeaveEnable)) {
                    //1表示关联调休
                    flowType += "_4leave";
                } else {
                    //0表示不关联调休
                    flowType += "_nonleave";
                }
                String key = resourceid + "|" + flowType;
                //df.format 默认是不四舍五入的 0.125这样的就会直接变成0.12了
                df.setMaximumFractionDigits(5);
                if (datas.containsKey(key)) {
                    double tmpVal = Util.getDoubleValue(Util.null2String(datas.get(key)), 0.0);
                    tmpVal += value;
                    datas.put(key, df.format(tmpVal));
                } else {
                    datas.put(key, df.format(value));
                }
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
        }
        return datas;
    }

    /**
     * 获取人员加班时间总计
     *
     * @param id
     * @param flowData
     * @return
     */
    private String getOverTimeByUserId(String id, Map<String, Object> flowData) {
        String fieldValue = "";
        double workingDayOvertime_4leave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|workingDayOvertime_4leave")));
        workingDayOvertime_4leave = workingDayOvertime_4leave < 0 ? 0 : workingDayOvertime_4leave;
        double restDayOvertime_4leave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|restDayOvertime_4leave")));
        restDayOvertime_4leave = restDayOvertime_4leave < 0 ? 0 : restDayOvertime_4leave;
        double holidayOvertime_4leave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|holidayOvertime_4leave")));
        holidayOvertime_4leave = holidayOvertime_4leave < 0 ? 0 : holidayOvertime_4leave;

        double workingDayOvertime_nonleave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|workingDayOvertime_nonleave")));
        workingDayOvertime_nonleave = workingDayOvertime_nonleave < 0 ? 0 : workingDayOvertime_nonleave;
        double restDayOvertime_nonleave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|restDayOvertime_nonleave")));
        restDayOvertime_nonleave = restDayOvertime_nonleave < 0 ? 0 : restDayOvertime_nonleave;
        double holidayOvertime_nonleave = Util.getDoubleValue(Util.null2String(flowData.get(id + "|holidayOvertime_nonleave")));
        holidayOvertime_nonleave = holidayOvertime_nonleave < 0 ? 0 : holidayOvertime_nonleave;

        fieldValue = KQDurationCalculatorUtil.getDurationRound(String.valueOf(workingDayOvertime_4leave + restDayOvertime_4leave + holidayOvertime_4leave +
                workingDayOvertime_nonleave + restDayOvertime_nonleave + holidayOvertime_nonleave));

        if ("".equals(fieldValue)) {
            fieldValue = "0.00";
        }
        return fieldValue;
    }

    /**
     * 获取当月最后一天
     *
     * @return
     */
    private String getLastDayByMonth() {
        // 指定日期
        Date date = new Date();

        // 获取指定日期所在月份的最后一天
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        calendar.set(Calendar.DAY_OF_MONTH, calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
        Date lastDayOfMonth = calendar.getTime();

        String dates = DateUtil.formatDate(lastDayOfMonth, "yyyy-MM-dd");
        return dates;
    }


}
