package com.engine.hrm.cmd.codeseting;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.hrm.entity.RuleCodeType;
import com.engine.hrm.util.CodeRuleManager;
import com.engine.integration.util.StringUtils;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.resource.ResourceComInfo;

import java.util.HashMap;
import java.util.Map;

public class RegenerateCodeCmd extends AbstractCommonCommand<Map<String, Object>> {

    public RegenerateCodeCmd(Map<String, Object> params, User user) {
        this.params = params;
        this.user = user;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> apidata = new HashMap<>();
        try {
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            ResourceComInfo resourceComInfo = new ResourceComInfo();
        String serialtype = Util.null2String(params.get("serialtype"));
        String subcompanyid = Util.null2String(params.get("subcompanyid"));
        String deptid = Util.null2String(params.get("departmentid"));
        String jobtitlesid = Util.null2String(params.get("jobtitlesid"));
        String userid = Util.null2String(params.get("userid"));

        switch (RuleCodeType.getByValue(serialtype)) {
            case DEPARTMENT:
                if (StringUtils.isEmpty(subcompanyid)) subcompanyid = departmentComInfo.getSubcompanyid1(deptid);
                break;
            case USER:
                if (StringUtils.isEmpty(subcompanyid)) subcompanyid = resourceComInfo.getSubCompanyID(userid);
                if (StringUtils.isEmpty(deptid)) deptid = resourceComInfo.getDepartmentID(userid);
                if (StringUtils.isEmpty(jobtitlesid)) jobtitlesid = resourceComInfo.getJobTitle(userid);
                break;
        }

        String code = CodeRuleManager.getCodeRuleManager().generateRuleCode(Enum.valueOf(RuleCodeType.class, serialtype), subcompanyid, deptid, jobtitlesid, null);
        apidata.put("code", code);
        } catch (Exception e) {
            writeLog(e);
            apidata.put("api_status", false);
            apidata.put("api_errormsg", e.getMessage());
        }
        return apidata;
    }
}
