package com.engine.hsCheck.web;

import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.hsCheck.service.CheckService;
import com.engine.hsCheck.service.impl.CheckServiceImpl;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class QkCheckAction {


    public CheckService getService(){
        return (CheckService) ServiceUtil.getService(CheckServiceImpl.class);
    }

    @POST
    @Path("/check")
    @Produces(MediaType.TEXT_PLAIN)
    public String doGetPurchaseReq1(@Context HttpServletRequest request, @Context HttpServletResponse response){

        Map<String, Object> apidatas = new HashMap<String, Object>();
        BaseBean bb = new BaseBean();
        try {
            apidatas.putAll(getService().check(ParamUtil.request2Map(request)));
        } catch (Exception e) {
            e.printStackTrace();
//            apidatas.put("api_status", false);
//            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(apidatas);
    }


    /**
     * 建模台账重新格式化考勤
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/kqFormatByMode")
    @Produces({MediaType.TEXT_PLAIN})
    public String kqFormatByMode(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            apidatas.putAll(getService().kqFormatByMode(ParamUtil.request2Map(request)));
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("code","500");
            apidatas.put("msg","fail");
        }
        return JSONObject.toJSONString(apidatas);
    }

    /**
     * 获取人员信息
     * @param request
     * @param response
     * @return
     */
    @GET
    @Path("/getPersonInfo")
    @Produces({MediaType.TEXT_PLAIN})
    public String getPersonInfo(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> apidatas = new HashMap<String, Object>();
        try{
            RecordSet rs = new RecordSet();
            Map<String, Object> params = ParamUtil.request2Map(request);
            String userid = Util.null2String(params.get("userid"));
            String xb = "";
            String zt = "";
            String sql = "select sex,status from HrmResource where id = ?";
            rs.executeQuery(sql,userid);
            if(rs.next()){
                xb = Util.null2String(rs.getString("sex"));
                zt = Util.null2String(rs.getString("status"));
            }
            apidatas.put("code","200");
            apidatas.put("xb",xb);
            apidatas.put("zt",zt);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("code","500");
            apidatas.put("msg","fail");
        }
        return JSONObject.toJSONString(apidatas);
    }


}
