package com.engine.kq.util;

import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * hansang考勤假期计算相关工具类
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2023/9/12
 */

public class UtilKQHS {
    /**
     * 判断是否查询年份是育儿假最后一年（即第三年）
     * @return
     */
    public static boolean isLastYearChildcareLeave(String userid,String searchYear) {
        boolean flag = false;
        RecordSet rs = new RecordSet();
        rs.executeQuery("select csrq from uf_jt where gx = 2 and ry = ? ORDER BY csrq desc limit 1",userid);
        String csrq = "";
        while (rs.next()){
            csrq = Util.null2String(rs.getString("csrq"));
        }
        if(!"".equals(csrq)){
            String year = Util.object2String(Util.getIntValue(csrq.substring(0,4))+3);
            if(year.equals(searchYear)){
                flag = true;
            }
        }
        return flag;
    }




    /**
     * 获取人员的小孩满三周岁日期
     * @param userid
     * @param searchDate
     * @return
     */
    public static String getLastDateChildcareLeave(String userid,String searchDate){
        RecordSet rs = new RecordSet();
        rs.executeQuery("select csrq from uf_jt where gx = 2 and ry = ? ORDER BY csrq desc limit 1",userid);
        String date = "";
        while (rs.next()){
            String csrq = Util.null2String(rs.getString("csrq"));
            if("".equals(csrq)){
                date = searchDate;
            }else{
                try {
                    date = dealDate(csrq);
                }catch (ParseException e) {
                    e.getMessage();
                }
            }
        }

        return date;
    }


    public static String dealDate(String date) throws ParseException {
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        Date dt=sdf.parse(date);
        Calendar rightNow = Calendar.getInstance();
        rightNow.setTime(dt);
        rightNow.add(Calendar.YEAR,+3);//日期减1年
//        rightNow.add(Calendar.MONTH,3);//日期加3个月
//        rightNow.add(Calendar.DAY_OF_YEAR ,10);//日期加10天
        Date dt1=rightNow.getTime();

        Calendar calendar = Calendar.getInstance();
        calendar.setTime(dt1);
        calendar.add(Calendar.DAY_OF_MONTH, -1); //当前时间减去一天，即一天前的时间

        // 获取减一天后的日期
        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH) + 1;
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        String months = "";
        String days = "";
        if(month < 10){
             months = "0"+month;
        }else{
            months = month+"";
        }
        if(day < 10){
            days = "0"+day;
        }else{
            days = day + "";
        }
        return year+"-"+months+"-"+days;
    }

    //比较时间大小
    public static boolean compareDate(String start, String end) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        try {
            Date date1 = simpleDateFormat.parse(start);
            Date date2 = simpleDateFormat.parse(end);
            if (date1.getTime() < date2.getTime()) {
                return true;
            }
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        return false;
    }

//    public static void main(String[] args) {
//        System.out.println(handleAmount("7.60","7.89"));
//    }

    public static String handleAmount(String restAmount,String baseAmount){

        String[] arr = restAmount.split("\\.");

        String restPart0 = arr[0];
        String restPart1 = arr[1];
        System.out.println("restPart0:"+restPart0);
        System.out.println("restPart1:"+restPart1);
        double a = 0.00;
        double base = Util.getDoubleValue(baseAmount);

        if(Util.getIntValue(restPart1) > 50){
            a = Util.getIntValue(restPart0) + 1.00;
            if(a > base){
                a = Util.getIntValue(restPart0) + 0.5;
            }
        }else{
            a = Util.getIntValue(restPart0) + 0.00;
        }
        return Util.object2String(a);
    }


}
