package com.engine.leshanvc.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.biz.chain.shiftinfo.ShiftInfoBean;
import com.engine.kq.util.KQDurationCalculatorUtil;
import weaver.hrm.User;
import weaver.wechat.util.Utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2023/3/3
 * @Version V1.0
 **/
public class KqWorkflowRangeLimitCmd extends AbstractCommonCommand<Map<String, Object>> {


    public KqWorkflowRangeLimitCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> data = new HashMap<>(16);
        boolean result = false;
        String resourceId = Utils.null2String(params.get("resourceId"));
        String fromDate = Utils.null2String(params.get("fromDate"));
        String fromTime = Utils.null2String(params.get("fromTime"));
        String toDate = Utils.null2String(params.get("toDate"));
        String toTime = Utils.null2String(params.get("toTime"));

        User user1 = new User();
        user1.setUid(Integer.valueOf(resourceId));
        ShiftInfoBean shiftInfoBean = KQDurationCalculatorUtil.getWorkTime(user1, fromDate, false, false);
        ShiftInfoBean shiftInfoBean1 = KQDurationCalculatorUtil.getWorkTime(user1, toDate, false, false);
        if (Objects.nonNull(shiftInfoBean) && Objects.nonNull(shiftInfoBean1)) {
            List<String[]> workAcrossTime = shiftInfoBean.getWorkAcrossTime();
            List<String[]> workAcrossTime1 = shiftInfoBean1.getWorkAcrossTime();
            if (fromTime.compareTo(workAcrossTime.get(0)[0]) >= 0 && fromTime.compareTo(workAcrossTime.get(0)[1]) < 0
                    && toTime.compareTo(workAcrossTime1.get(0)[0]) > 0 && toTime.compareTo(workAcrossTime1.get(0)[1]) <= 0) {
                result = true;
            }
        }
        data.put("result",result);
        return data;
    }
}
