package com.engine.leshanvc.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import lombok.SneakyThrows;
import weaver.conn.RecordSet;
import weaver.hrm.User;
import weaver.hrm.resource.ResourceComInfo;
import weaver.wechat.util.Utils;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2023/3/8
 * @Version V1.0
 **/
public class WorkflowCheckCmd extends AbstractCommonCommand<Map<String, Object>> {

    public WorkflowCheckCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @SneakyThrows
    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> data = new HashMap<>(16);
        String workflowId = Utils.null2String(params.get("workflowId"));
        String resourceId = Utils.null2String(params.get("resourceId"));
        String requestId = Utils.null2String(params.get("requestid"));

        RecordSet rs = new RecordSet();
        ResourceComInfo resourceComInfo = new ResourceComInfo();
        rs.executeQuery("select requestname,creater from workflow_requestbase where workflowid = ? and creater = ? " +
                " and requestid != ? and currentnodetype not in (0,3)",workflowId,resourceId,requestId);
        if (rs.next()) {
            String requestName = Utils.null2String(rs.getString("requestname"));
            String creater = Utils.null2String(rs.getString("creater"));
            String lastname = resourceComInfo.getLastname(creater);
            data.put("result",true);
            data.put("requestName",requestName);
            data.put("lastname",lastname);
        }

        return data;
    }
}
