package com.engine.leshanvc.service.impl;

import com.engine.core.impl.Service;
import com.engine.leshanvc.service.EntryCommitFormModeService;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.PasswordUtil;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.interfaces.leshanvc.workflow.entity.FieldMapEntity;
import weaver.interfaces.leshanvc.workflow.util.ResourceSyncUtil;
import weaver.soa.workflow.request.Property;
import weaver.systeminfo.SystemEnv;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Author ml
 * @Date 2023/3/3 17:46
 * @Description This is description of class
 * @Since version-1.0
 */
public class EntryCommitFormModeServiceImpl extends Service implements EntryCommitFormModeService {
    BaseBean baseBean = new BaseBean();
    @Override
    public Map<String, Object> entryCommit(Map<String, Object> params) {
        Map<String, Object> result = new HashMap<>();
        RecordSet rs = new RecordSet();
        // 查询字段预处理
        List<String> fieldNameList = new ArrayList<>();
        String fieldsSql = "select wf_field,ec_type from uf_hs_field_map";
        baseBean.writeLog("fieldsSql:" + fieldsSql);
        rs.executeQuery(fieldsSql);
        while (rs.next()) {
            fieldNameList.add(rs.getString("wf_field"));
        }
        String fieldNames = fieldNameList.stream().collect(Collectors.joining(","));
        List<Property> propertyList = new ArrayList<>();
        Property[] properties;

        String sql = "select " + fieldNames + " from uf_rzgl where id=" + Util.null2String(params.get("id"));
        baseBean.writeLog("动态拼接字段查询sql:" + sql);
        rs.executeQuery(sql);
        if (rs.next()) {
            for (String s : fieldNameList) {
                Property property = new Property();
                property.setName(s);
                property.setValue(rs.getString(s));
                propertyList.add(property);
            }
        }

        if (propertyList.size() == 0) {
            result.put("type", 2);
            result.put("msg", "未查询到入职管理表中对应数据");
            baseBean.writeLog("未查询到入职管理表中对应数据");
            return result;
        }
        properties = new Property[propertyList.size()];
        properties = propertyList.toArray(properties);

        // 根据手机号+姓名校验数据存在
        String sjhm = null;
        String xm = null;
        for (Property property : properties) {
            if ("sjhm".equals(property.getName())) {
                sjhm = property.getValue();
            }
            if ("xm".equals(property.getName())) {
                xm = property.getValue();
            }
        }
        rs.execute("select * from hrmresource where mobile='" + sjhm + "' and lastname='" + xm + "'");
        if (rs.next()) {
            result.put("type", 2);
            result.put("msg", "当前人员已存在，无法重复添加");
            baseBean.writeLog("当前人员已存在，无法重复添加");
            return result;
        }
        // 获取人员主表(系统表)字段
        String sysSql = "select ec_field,wf_field,ec_type from uf_hs_field_map where ec_type=0";
        rs.executeQuery(sysSql);
        // 系统字段
        Map<String, String> fieldsMap = new HashMap<>();
        StringBuilder updateSysFields = new StringBuilder();
        while (rs.next()) {
            fieldsMap.put(rs.getString("wf_field"), rs.getString("ec_field"));
        }
        //取系统字段对应字段数据
        Map<String, Object> resMap = new HashMap<>();
        for (Property p : properties) {
            if (fieldsMap.containsKey(p.getName())) {
                resMap.put(fieldsMap.get(p.getName()), p.getValue());
                baseBean.writeLog("resMap参数值："+fieldsMap.get(p.getName()) + "++" + p.getValue());
                updateSysFields.append(fieldsMap.get(p.getName())).append("=").append("'").append(p.getValue()).append("'").append(",");
            }
        }
        baseBean.writeLog("updateSysFields="+updateSysFields);
        boolean flag = false;
        //人员表数据插入
        resMap.put("status","0");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String currentDate = sdf.format(new Date());
        resMap.put("companystartdate",currentDate);
        boolean canEdit = HrmUserVarify.checkUserRight("HrmResourceEdit:Edit", user);
        if (!canEdit) {
            result.put("msg", "人员新增失败，当前用户没有权限");
            baseBean.writeLog("人员新增失败，当前用户没有权限");
            return result;
        }
        Map<String, Object> retMap = ResourceSyncUtil.addResource(user, resMap);
        if (!"1".equals(retMap.get("status"))) {
            result.put("type", 2);
            result.put("msg", "人员新增失败，请联系管理员");
            baseBean.writeLog("人员新增失败，请联系管理员");
            return result;
        }
        //查询拼接
        String defId = "";
        //查询新增成功的人员id
        String queryHrmSql = "select id, workcode from hrmresource h where h.lastname = '" + resMap.get("lastname") + "' and h.mobile = '" + resMap.get("mobile") + "'";
        flag = rs.executeQuery(queryHrmSql);
        RecordSet recordSet = new RecordSet();
        baseBean.writeLog("查询新增人员sql：" + queryHrmSql);
        if (rs.next()) {
            defId = rs.getString("id");
            String encrptPassword = "";
            String salt = "";
            if (org.apache.commons.lang3.StringUtils.isNotBlank(rs.getString("workcode"))) {
                String[] encrypts = PasswordUtil.encrypt(rs.getString("workcode"));
                encrptPassword = encrypts[0];
                salt = encrypts[1];
            }
            String updateSql = "update hrmresource set "+updateSysFields+" loginid='" + rs.getString("workcode") + "',password='" + encrptPassword + "',salt='" + salt + "',certificatenum='"+Util.null2String(resMap.get("certificatenum"))+"' where id=" + defId;
            recordSet.execute(updateSql);

        } else {
            result.put("type", 2);
            result.put("msg", "未查到对应人员Id，请联系管理员");
            baseBean.writeLog("未查到对应人员Id，请联系管理员");
            return result;
        }
        Map<String, String> defMap;
        rs.execute("select DISTINCT(ec_type) as ec_type from uf_hs_field_map where ec_type!=0");
        List<String> ecTypes = new ArrayList<>();
        while (rs.next()) {
            ecTypes.add(rs.getString("ec_type"));
        }
        // 自定义表数据插入
        for (String s : ecTypes) {
            defMap = getFields(s, properties);
            if (defMap != null) {
                String defFields = "id, " + defMap.get("defFields");
                String defFieldsValue = defId + ", " + defMap.get("defFieldsValue");
                String insertSql = "insert into cus_fielddata(" + defFields + ") values (" + defFieldsValue + ")";
                flag = rs.execute(insertSql);
                if (!flag) {
                    recordSet.execute("delete from hrmresource where id=" + defId);
                    recordSet.execute("delete from cus_fielddata where id=" + defId);
                    result.put("type", 2);
                    result.put("msg", "自定义字段类型" + s + "数据插入失败，请联系管理员检查字段");
                    baseBean.writeLog("自定义字段类型" + s + "数据插入失败，请联系管理员检查字段");
                    return result;
                }
            }
        }
        //修改建模表中人员状态
        if (flag) {
            recordSet.execute("update uf_rzgl set rzzt='3' where xm='" + resMap.get("lastname") + "' and sfzh='" + resMap.get("certificatenum") + "'");
            result.put("type", 3);
            result.put("msg", "入职提交成功！");
            baseBean.writeLog("入职提交成功!");
        }

        return result;

    }


    /**
     * 自定义字段分类获取
     * @param type
     * @param properties
     */
    private Map<String,String> getFields(String  type,Property[] properties) {
        String ecType = "1";
        switch (type){
            case "2":
                ecType = "-1";
                break;
            case "3":
                ecType = "1";
                break;
            case "4":
                ecType = "3";
                break;
            default: break;
        }
        RecordSet rs = new RecordSet();
        List<FieldMapEntity> fieldsList = new ArrayList<>();
        List<Property> propertyListWf = new ArrayList<>();
        Map<String,String> fieldsMapDef = new HashMap<>();
        // 自定义表字段
        String defSql = "select ec_field,wf_field,ec_type from uf_hs_field_map where ec_type='" + type +"'";
        rs.execute(defSql);
        while (rs.next()) {
            FieldMapEntity fieldMapEntity = new FieldMapEntity();
            fieldMapEntity.setEcField(rs.getString("ec_field"));
            fieldMapEntity.setWfField(rs.getString("wf_field"));
            fieldMapEntity.setEcType(rs.getString("ec_type"));
            fieldsList.add(fieldMapEntity);
            Property property = new Property();
            property.setName(rs.getString("wf_field"));
            propertyListWf.add(property);
        }
        if (fieldsList.size()<1){
            return null;
        }
        // 拼接sql字段
        String defFields = fieldsList.stream().map(FieldMapEntity::getEcField).collect(Collectors.joining(","));
        defFields = " scope, scopeid," + defFields;
        //交集字段和数据
        List<Property> propertyListFront = Arrays.asList(properties);
        Map<String, Property> frontMap = propertyListFront.stream().collect(Collectors.toMap(Property::getName,(p) -> p));
        for (FieldMapEntity f : fieldsList) {
            if (frontMap.containsKey(f.getWfField())) {
                f.setEcValue(Util.null2String(frontMap.get(f.getWfField()).getValue()));
            }
        }
        String defFieldsValue2 = fieldsList.stream().map(fieldMapEntity -> StringUtils.isBlank(fieldMapEntity.getEcValue()) ? "null" : "'"+fieldMapEntity.getEcValue()+"'").collect(Collectors.joining(","));
        System.out.println(defFieldsValue2);
        List<Property> propertyListBack = propertyListFront.stream()
                .filter(property -> propertyListWf.stream()
                        .map(Property::getName)
                        .anyMatch(name -> Objects.equals(property.getName(), name)))
                .collect(Collectors.toList());
        String defFieldsValue = propertyListBack.stream().map(property -> "".equals(property.getValue()) ? "null" : property.getValue()).collect(Collectors.joining(","));
        defFieldsValue2 = " 'HrmCustomFieldByInfoType', " + ecType + "," + defFieldsValue2;
        Map<String ,String> resFieldMap = new HashMap<>();
        resFieldMap.put("defFields",defFields);
        resFieldMap.put("defFieldsValue",defFieldsValue2);
        return resFieldMap;
    }
}
