package com.engine.leshanvc.service.impl;

import com.engine.core.impl.Service;
import com.engine.leshanvc.service.LeaverWorkflowService;
import com.engine.leshanvc.util.HsDateUtil;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;

import java.util.HashMap;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/04/19
 * @version: 1.0
 */
public class LeaverWorkflowServiceImpl extends Service implements LeaverWorkflowService {
    private static final String DAY_SHIFT_ID = "2";

    @Override
    public Map<String, Object> getEndDate(Map<String, Object> params) {
        Map<String, Object> returnMap = new HashMap<>(16);
        String newLeaveType = Util.null2String(params.get("newLeaveType"));
        String resourceId = Util.null2String(params.get("resourceId"));
        String fromDate = Util.null2String(params.get("fromDate"));
        String startTime = "";
        String endTime = "";
        String viewAttr = "1";

        Boolean includeHoliday = null;

        if (StringUtils.isBlank(fromDate)) {
            fromDate = DateUtil.getCurrentDate();
        }

        RecordSet rs = new RecordSet();
        String sql = "select times,onoffworktype,record from kq_shiftonoffworksections where serialid = ? order by record";
        rs.executeQuery(sql, DAY_SHIFT_ID);
        while (rs.next()) {
            if ("start".equalsIgnoreCase(rs.getString("onoffworktype")) && "0".equals(rs.getString("record"))) {
                startTime = rs.getString("times");
            } else if ("end".equalsIgnoreCase(rs.getString("onoffworktype"))) {
                endTime = rs.getString("times");
            }
        }

        // 根据白名单，判断结束时间是否可以自行调整
        sql = "select * from uf_xjlx where qjlx = ? and qjr = ? and sfqy = 1 ";
        rs.executeQuery(sql, newLeaveType, resourceId);
        if (rs.next()) {
            viewAttr = "3";
        }

        // 根据假期类型，判断是否包含节假日
        switch (newLeaveType) {
            // 陪产假、婚假、丧假
            case "9":
            case "32":
            case "35":
                includeHoliday = true;
                break;
            // 产假、产假（剖腹产顺延）、产假（多胞胎顺延）
            case "8":
            case "17":
            case "18":
                includeHoliday = false;
                break;
            default:
                viewAttr = "3";
                break;

        }

        Integer holidayAmount = HsDateUtil.getHolidayAmount(resourceId, newLeaveType, fromDate);
        String endDate;
        if (null != includeHoliday && holidayAmount != 0) {
            endDate = HsDateUtil.addDay(resourceId, holidayAmount, fromDate, includeHoliday);
        } else {
            endDate = "";
            viewAttr = "3";
        }
        returnMap.put("endDate", endDate);
        returnMap.put("endTime", endTime);
        returnMap.put("startDate", fromDate);
        returnMap.put("startTime", startTime);
        returnMap.put("viewAttr", viewAttr);

        return returnMap;
    }
}
