package com.engine.leshanvc.service.impl;

import com.engine.core.impl.Service;
import com.engine.leshanvc.service.LzWorkflowManageService;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LzWorkflowManageServiceImpl extends Service implements LzWorkflowManageService {
    BaseBean baseBean = new BaseBean();
    @Override
    public Map<String, Object> getHrmInfoByLinSup(Map<String, Object> params) {
        Map<String,Object> data = new HashMap<>();
        String lineSup = Util.null2String(params.get("userid"));
        List<HrmInfo> hrmInfoList = new ArrayList<>();
        RecordSet rs = new RecordSet();
        rs.execute("select a.id,b.lastname,b.departmentid,field35,jobtitle,field102,xnfzmc,b.workcode,c.departmentname,d.jobtitlename from cus_fielddata a \n" +
                "inner join hrmresource b on a.id=b.id " +
                "left join hrmdepartment c ON b.DEPARTMENTID=c.id\n" +
                "left join hrmjobtitles d on b.JOBTITLE=d.ID \n" +
                "left join uf_xlfz e on a.field102 =e.xnfzbm \n" +
                "where scope ='HrmCustomFieldByInfoType' and b.status < 4\n" +
                "and scopeid ='-1' and field89='"+lineSup+"'");
        while (rs.next()) {
            String userId = rs.getString("id");
            String bm = rs.getString("departmentid");
            String zjj = rs.getString("field35");
            String gw = rs.getString("jobtitle");
            String xnfz = rs.getString("field102");
            String xnfzmc = rs.getString("xnfzmc");
            String gh = rs.getString("workcode");
            String departmentname = rs.getString("departmentname");
            String jobtitlename = rs.getString("jobtitlename");

            String dyyljjbxs = getJBTimes(userId);
            String dyljjbcexs = getJbCHETimes(bm,zjj,gw);
            String sfgpczg = getSfgpczg(bm,zjj,gw);
            hrmInfoList.add(new HrmInfo(userId,rs.getString("lastname"),bm,dyyljjbxs,dyljjbcexs,gh,gw,sfgpczg,xnfz,xnfzmc,zjj,departmentname,jobtitlename));
        }
        data.put("data",hrmInfoList);

        return data;
    }

    /**
     * 当月已累计加班时长
     */
    String getJBTimes(String userId){
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery("select  sum(cast(duration_min as decimal(18,4)))/60 jbtimes \n" +
                "from kq_flow_overtime b\n" +
                "where  date_format(b.belongdate,'%Y-%m')=date_format(curdate(),'%Y-%m') and b.resourceid=? ",userId);
        String jbTimes = "";
        if(recordSet.next()){
            jbTimes = Util.null2String(recordSet.getString("jbtimes"));
        }
        return jbTimes;
    }
    /**
     * 当月累计加班超额（小时）
     */
    String getJbCHETimes(String bm,String zjj,String gw){
        RecordSet recordSet = new RecordSet();
        recordSet.executeQuery("select a.dyljjbcexs from uf_jbfjsp a where a.bm =? " +
                "and a.zjj=? and gw=? " +
                "union all select 500 ",bm,zjj,gw);
        String dyljjbcexs = "";
        if (recordSet.next()) {
            dyljjbcexs = Util.null2String(recordSet.getString("dyljjbcexs"));
        }
        return dyljjbcexs;
    }


    /**
     * 是否过PC主管
     */
    public String getSfgpczg(String bm,String zjj,String gw){
        String sfgpczg = "";
        RecordSet rs = new RecordSet();
        rs.executeQuery(" select sfgpczg from uf_jbfjsp  " +
                " where bm=? and zjj=? and gw=?  ",new Object[]{bm,zjj,gw});
        if (rs.next()) {
            sfgpczg = Util.null2String(rs.getString("sfgpczg"));
        }
        return sfgpczg;
    }


    private static class HrmInfo {
        /**
         * 人员id
         */
        private String id;
        /**
         * 人员姓名
         */
        private String lastName;
        /**
         * 部门id
         */
        private String departmentId;

        /**
         * 当月已累计加班小时
         */
        private String dyyljjbxs;

        /**
         * 当月累计加班超额（小时）
         */
        private String dyljjbcexs;

        /**
         * 工号
         */
        private String gh;

        /**
         * 岗位
         */
        private String gw;

        /**
         * 是否过pc主管
         */
        private String sfgpczg;

        /**
         * 线内分组
         */
        private String xnfz;

        /**
         * 线内分组
         */
        private String xnfzmc;

        private String zjj;
        private String deptName;
        private String jobTitleName;


        public HrmInfo(String id, String lastName, String departmentId, String dyyljjbxs, String dyljjbcexs, String gh, String gw,String sfgpczg, String xnfz,String xnfzmc, String zjj, String deptName, String jobTitleName) {
            this.id = id;
            this.lastName = lastName;
            this.departmentId = departmentId;
            this.dyyljjbxs = dyyljjbxs;
            this.dyljjbcexs = dyljjbcexs;
            this.gh = gh;
            this.gw = gw;
            this.sfgpczg = sfgpczg;
            this.xnfz = xnfz;
            this.xnfzmc = xnfzmc;
            this.zjj = zjj;
            this.deptName = deptName;
            this.jobTitleName = jobTitleName;
        }

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getLastName() {
            return lastName;
        }

        public void setLastName(String lastName) {
            this.lastName = lastName;
        }

        public String getDepartmentId() {
            return departmentId;
        }

        public void setDepartmentId(String departmentId) {
            this.departmentId = departmentId;
        }

        public String getDyyljjbxs() {
            return dyyljjbxs;
        }

        public void setDyyljjbxs(String dyyljjbxs) {
            this.dyyljjbxs = dyyljjbxs;
        }

        public String getDyljjbcexs() {
            return dyljjbcexs;
        }

        public void setDyljjbcexs(String dyljjbcexs) {
            this.dyljjbcexs = dyljjbcexs;
        }

        public String getGh() {
            return gh;
        }

        public void setGh(String gh) {
            this.gh = gh;
        }

        public String getGw() {
            return gw;
        }

        public void setGw(String gw) {
            this.gw = gw;
        }

        public String getSfgpczg() {
            return sfgpczg;
        }

        public void setSfgpczg(String sfgpczg) {
            this.sfgpczg = sfgpczg;
        }

        public String getXnfz() {
            return xnfz;
        }

        public void setXnfz(String xnfz) {
            this.xnfz = xnfz;
        }

        public String getXnfzmc() {
            return xnfzmc;
        }

        public void setXnfzmc(String xnfzmc) {
            this.xnfzmc = xnfzmc;
        }

        public String getZjj() {
            return zjj;
        }

        public void setZjj(String zjj) {
            this.zjj = zjj;
        }

        public String getDeptName() {
            return deptName;
        }

        public void setDeptName(String deptName) {
            this.deptName = deptName;
        }

        public String getJobTitleName() {
            return jobTitleName;
        }

        public void setJobTitleName(String jobTitleName) {
            this.jobTitleName = jobTitleName;
        }
    }
}
