package com.engine.leshanvc.service.impl;

import com.engine.core.impl.Service;
import com.engine.leshanvc.service.ResourceCardService;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.systeminfo.systemright.CheckUserRight;

import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2023/04/20
 * @version: 1.0
 */
public class ResourceCardServiceImpl extends Service implements ResourceCardService {

    @Override
    public void editResourceCard(Map<String, Object> params) {
        String field102 = "";
        Integer lineLeaderId = null;
        String probationDate = "";
        String dimissionDate = "";
        RecordSet rs = new RecordSet();

        String resourceId = Util.null2String(params.get("id"));
        String roleName = Util.null2String(params.get("roleName"));
        // 查询线内分组字段的值
        String sql = "select field102 from cus_fielddata cf where scope ='HrmCustomFieldByInfoType' and scopeid ='-1' and id = ?";
        rs.executeQuery(sql, resourceId);
        if (rs.next()) {
            field102 = rs.getString("field102");
        }
        // 查询分组的
        sql = "select xc from uf_xlfz where xnfzbm = ?";
        rs.executeQuery(sql, field102);
        if (rs.next()) {
            lineLeaderId = rs.getInt("xc");
        }
        // 补充线长字段，判断当前线长是否拥有线长角色
        sql = "update cus_fielddata set field89 = ? where scope ='HrmCustomFieldByInfoType' and scopeid ='-1' and id = ? ";
        rs.executeUpdate(sql, lineLeaderId, resourceId);
        sql = "select id from hrmroles where ROLESMARK = ? ";
        rs.executeQuery(sql, roleName);
        if (rs.next()) {
            addResourceRoles(String.valueOf(lineLeaderId), rs.getString("id"));
        }

        // 查询转正日期、离职日期
        sql = "select field18,field82 from cus_fielddata where scope ='HrmCustomFieldByInfoType' and scopeid ='3' and id = ?";
        rs.executeQuery(sql, resourceId);
        if (rs.next()) {
            probationDate = rs.getString("field18");
            dimissionDate = rs.getString("field82");
        }
        // 修改当前人员为正式(转正日期小于等于当前日期)
        if (probationDate.length() >0 ) {
            if (probationDate.compareTo(DateUtil.getCurrentDate()) <= 0) {
                sql = "update hrmresource set status = 1 where id = ?";
                rs.executeUpdate(sql, resourceId);
            }
        }
        // 修改当前人员为离职（离职日期小于当前日期）
        if (dimissionDate.length() > 0) {
            if (dimissionDate.compareTo(DateUtil.getCurrentDate()) <0) {
                sql = "update hrmresource set status = 5 where id = ?";
                rs.executeUpdate(sql,resourceId);
            }
        }
    }


    /**
     * 给人员添加角色
     *
     * @param resourceId
     * @param roleId
     */
    private void addResourceRoles(String resourceId, String roleId) {
        RecordSet rs = new RecordSet();

        // 角色级别：总部
        String roleLevel = "2";
        CheckUserRight checkUserRight = new CheckUserRight();
        if (!"".equals(roleId)) {
            boolean isExist = false;
            String sql = " select count(id) from HrmRoleMembers where roleid=" + roleId + " and resourceid = " + resourceId + " and resourcetype = 1 ";
            rs.executeQuery(sql);
            if (rs.next()) {
                if (rs.getInt(1) > 0) {
                    isExist = true;
                }
            }
            if (!isExist) {
                sql = " INSERT INTO HrmRoleMembers ( roleid ,resourceid ,rolelevel ,resourcetype) " +
                        " VALUES  ( " + roleId + ", " + resourceId + " , '" + roleLevel + "', '1')";
            }
            rs.executeUpdate(sql);

        }
        checkUserRight.removeMemberRoleCache();
        checkUserRight.removeRoleRightdetailCache();
    }
}
