package com.engine.leshanvc.service.impl;

import com.engine.core.impl.Service;
import com.engine.kq.biz.KQGroupMemberComInfo;
import com.engine.kq.biz.KQHolidaySetBiz;
import com.engine.leshanvc.service.SyncXcDataService;
import org.apache.commons.lang3.StringUtils;
import org.apache.tools.ant.util.DateUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.PasswordUtil;
import weaver.general.Util;
import weaver.hrm.HrmUserVarify;
import weaver.interfaces.leshanvc.workflow.util.ResourceSyncUtil;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

public class SyncXcDataServiceImpl extends Service implements SyncXcDataService {
    BaseBean baseBean = new BaseBean();
    static String dateFormat = "yyyy-MM-dd";
    static SimpleDateFormat format = new SimpleDateFormat(dateFormat);

    @Override
    public Map<String, Object> syncXcData(Map<String, Object> params) {
        Map<String, Object> data = new HashMap<>(16);
        baseBean.writeLog("同步线长信息至花名册");
        RecordSet recordSet = new RecordSet();
        Boolean boo = false;
        try {
            boo = recordSet.execute("update cus_fielddata a, uf_xlfz b \n" +
                    "set a.field89=SUBSTRING_INDEX(b.xc,',',1) where a.SCOPEID='-1' and a.SCOPE='HrmCustomFieldByInfoType' and a.field102=b.xnfzbm ");
            if (boo) {
                data.put("status","success");
                data.put("msg","线长信息同步成功！");
            }
        }catch (Exception e) {
            data.put("status","error");
            data.put("msg","线长信息同步失败，请联系管理员！");
            baseBean.writeLog(e);
        }
        return data;
    }

    @Override
    public Map<String, Object> nonOfficeUpload(Map<String, Object> params) {
        Map<String, Object> result = new HashMap<String, Object>();
        try {
            String ids = Util.null2String(params.get("ids"));
            boolean canEdit = HrmUserVarify.checkUserRight("HrmResourceEdit:Edit", user);
            if (!canEdit) {
                baseBean.writeLog("人员新增失败，当前用户不具备权限");
                result.put("msg", "人员新增失败，当前用户不具备权限");
                result.put("status", "error");
                return result;
            }
            String[] idStr = ids.split(",");
            for (String s : idStr) {
                //------请在下面编写业务逻辑代码------
                RecordSet rs = new RecordSet();
                rs.executeQuery("select sfzhm,xm,xb,mz,csrq,jtzz,ksyxq,jzyxq,sfrhmc from uf_sfzxxgl where id=?", s);
                Map<String, Object> paraMap = new HashMap<>();
                String defId = null;
                RecordSet recordSet = new RecordSet();
                if (rs.next()) {
                    String xm = Util.null2String("xm");
                    paraMap.put("certificatenum", Util.null2String(rs.getString("sfzhm")));
                    paraMap.put("lastname", Util.null2String(rs.getString("xm")));
                    paraMap.put("sex", Util.null2String(rs.getString("xb")));
                    paraMap.put("folk", Util.null2String(rs.getString("mz")));
                    paraMap.put("birthday", Util.null2String(rs.getString("csrq")));
                    paraMap.put("regresidentplace", Util.null2String(rs.getString("jtzz")));
                    paraMap.put("status", "0");
                    paraMap.put("ksyxq", Util.null2String(rs.getString("ksyxq")));
                    paraMap.put("jzyxq", Util.null2String(rs.getString("jzyxq")));
                    if (StringUtils.isNotBlank(rs.getString("sfrhmc"))) {
                        recordSet.executeQuery("select id from hrmresource where CERTIFICATENUM='"+Util.null2String(rs.getString("sfzhm"))+"' and status < 4");
                        if (recordSet.next()) {
                            baseBean.writeLog("【"+xm+"】已存在花名册中，系统自动更新数据！！");
                            String updateHrmSql = "update hrmresource set CERTIFICATENUM='"+paraMap.get("certificatenum")+"', " +
                                    "LASTNAME='"+paraMap.get("lastname")+"',FOLK='"+paraMap.get("folk")+"',BIRTHDAY='"+paraMap.get("birthday")+"', " +
                                    "REGRESIDENTPLACE='"+paraMap.get("regresidentplace")+"',SEX='"+paraMap.get("sex")+"' where id='"+Util.null2String(recordSet.getString("id"))+"'";
                            String updateCusSql = "update cus_fielddata set field103='"+paraMap.get("ksyxq")+"',field104='"+paraMap.get("jzyxq")+"'" +
                                    " where id='"+Util.null2String(recordSet.getString("id"))+"' and scopeid = 1";
                            rs.execute(updateHrmSql);
                            rs.execute(updateCusSql);
                            result.put("msg", "【"+xm+"】已存在花名册中，系统自动更新数据！！");
                            result.put("status", "warning");
                            return result;
                        }
                    }

                    Map<String, Object> retMap = ResourceSyncUtil.addResource(user, paraMap);
                    if (!"1".equals(retMap.get("status"))) {
                        baseBean.writeLog("人员新增失败，请联系管理员");
                        result.put("msg", "人员新增失败，请联系管理员");
                        result.put("status", "error");
                        return result;
                    } else {
                        defId = retMap.get("id").toString();

                        BaseBean bb = new BaseBean();
                        //新增人员自动排考勤组和班次
                        //考勤组
                        String kqz = "12";
                        //平时班次
                        String bcId = "2";
                        //周末班次
                        String zmbc = "15";
                        bb.writeLog("新增人员id:"+defId+"kqz:"+kqz+"bcId:"+bcId+"zmbc:"+zmbc);
                        //当前日期
                        String nowDate = DateUtils.format(new Date(), "yyyy-MM-dd");
                        //本月最后一天
//                            String toDate = TimeUtil.getMonthEndDay(nowDate);
                        String toDate = nowDate.substring(0,4)+"-12-31";
                        Set<String> all = new HashSet<>();
                        all.add(nowDate);
                        List<String> back = days(nowDate,toDate);
                        all.addAll(back);
                        all.add(toDate);
                        //插入考勤组
                        insertGroupMember(defId,kqz);
                        bb.writeLog("考勤组插入完成");
                        RecordSet rsn = new RecordSet();
                        //默认排班
                        String sql = "insert into kq_shiftschedule(kqdate,serialid,resourceid,groupid,isdelete)values(?,?,?,?,?)";
                        for (String date : all) {
                            boolean holiday = KQHolidaySetBiz.isHoliday(defId, date, true);
                            bb.writeLog("date:"+date+"holiday:"+holiday);
                            if (holiday) {
                                //节假日休息班
                                rsn.executeUpdate(sql, date, zmbc, defId, kqz, "0");
                            } else {
                                rsn.executeUpdate(sql, date, bcId, defId, kqz, "0");
                            }
                        }
                        bb.writeLog("默认排班插入完成");
                    }
                }
                String queryHrmSql = "select workcode from hrmresource h where h.id = '" + defId + "'";
                rs.executeQuery(queryHrmSql);

                String encrptPassword = "";
                String salt = "";
                if (rs.next()) {
                    if (StringUtils.isNotBlank(rs.getString("workcode"))) {
                        String[] encrypts = PasswordUtil.encrypt(rs.getString("workcode"));
                        encrptPassword = encrypts[0];
                        salt = encrypts[1];
                    }
                    recordSet.execute("update hrmresource set loginid='" + rs.getString("workcode") + "',password='" + encrptPassword + "',salt='" +
                            salt + "',certificatenum='" + Util.null2String(paraMap.get("certificatenum")) + "',folk='"+paraMap.get("folk")+"'," +
                            "birthday='"+paraMap.get("birthday")+"',regresidentplace='"+paraMap.get("regresidentplace")+"' where id=" + defId);
                } else {
                    baseBean.writeLog("未查到对应人员Id，请联系管理员");
                    result.put("msg", "未查到对应人员Id，请联系管理员");
                    result.put("status", "error");
                    return result;
                }

                // 自定义表cus_fielddata
                String insertCusFieldData = "insert cus_fielddata(scope,scopeid,id,field81,field103,field104) " +
                        "values ('HrmCustomFieldByInfoType','1'," + defId + ",'0','" + paraMap.get("ksyxq") + "','" + paraMap.get("jzyxq") + "')";
                rs.execute(insertCusFieldData);
                // 更新状态
                String updateStatus = "update uf_sfzxxgl set sfrhmc = '1' where id = ?";
                rs.executeUpdate(updateStatus, s);
            }
        } catch (Exception e) {
            result.put("msg", "内部错误，请联系管理员");
            result.put("status", "error");
        }
        result.put("status", "success");
        result.put("msg", "所选人员上岗成功！");
        return result;
    }


    @Override
    public Map<String, Object>  saveIDCard(Map<String, Object> params) {
        baseBean.writeLog(params);
        Map<String, Object> result = new HashMap<String, Object>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat df = new SimpleDateFormat("yyyyMMdd");
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("HH:mm:ss");

        String cardNo = Util.null2String(params.get("cardno"));
        String name = Util.null2String(params.get("name"));
        String sex = Util.null2String(params.get("sex")).equals("男") ? "0" : "1";
        String nation = Util.null2String(params.get("nation"));
        String born = null;
        String userLifeB = null;
        String userLifeE = null;
        try {
            Date date = df.parse(Util.null2String(params.get("born")));
            born = sdf.format(date);
            date = df.parse(Util.null2String(params.get("userlifeb")));
            userLifeB = sdf.format(date);
            date = df.parse(Util.null2String(params.get("userlifee")));
            userLifeE = sdf.format(date);
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
        String address = Util.null2String(params.get("address"));
        String police = Util.null2String(params.get("police"));
        String CardType = Util.null2String(params.get("CardType"));
        String photobase64 = Util.null2String(params.get("photobase64"));


        String modeUuid = UUID.randomUUID().toString();
        int modeDataCreate = user.getUID();

        String modeDataCreateDate = sdf.format(new Date());
        String modeDataCreateTime = LocalTime.now().format(formatter);

        RecordSet rs = new RecordSet();

        //身份证录入时，系统需检验
        //①　身份证号码相同 且 是否黑名单：否，身份信息可录入，并且提示：该入职员工属于二次入职。
        //②　身份证号码相同 且 是否黑名单：是，身份信息不可录入，提示：该入职员工属于黑名单，不允许入职。
        //③　身份证号码不相同 且 是否和名单：否，身份信息可录入。

        String msg = "身份证读取录入成功";
        boolean isBlack = false;
        String checkSql = "  select a.certificatenum ,b.field113 from hrmresource a " +
                " left join cus_fielddata b on a.id=b.id and b.scopeid =3 where certificatenum=?  ";
        rs.executeQuery(checkSql,cardNo);
        if(rs.next()){
            isBlack = Util.getIntValue(rs.getString("field113"))==0;
            if(isBlack){
                msg = "该入职员工属于黑名单，不允许入职";
            }else{
                msg = "该入职员工属于二次入职";
            }
        }

        if(!isBlack){
            String insertSql = "INSERT INTO uf_sfzxxgl (formmodeid, modedatacreater, modedatacreatertype, " +
                    "modedatacreatedate, modedatacreatetime, MODEUUID, sfzhm, xm, " +
                    "xb, mz, csrq, jtzz, ksyxq, jzyxq, sfrhmc, qfjg, zjlx, zjtx) VALUES (50, "+modeDataCreate+", 0, " +
                    "'"+modeDataCreateDate+"', '"+modeDataCreateTime+"', '"+modeUuid+"', '"+cardNo+"', '"+name+"'," +
                    sex+", '"+nation+"', '"+born+"', '"+address+"', '"+userLifeB+"', '"+userLifeE+"', 0, '"+police+"', '"+CardType+"', '"+photobase64+"')";
            boolean res = rs.execute(insertSql);
            if(!res){
                msg = "身份证读取录入失败";
            }

        }
        result.put("status","success");
        result.put("msg",msg);

        return result;
    }

    /**
     * 获取两个日期之间所有的日期
     * @param date1
     * @param date2
     * @return
     */
    public static ArrayList days(String date1, String date2) {
        ArrayList L = new ArrayList();
        if (date1.equals(date2)) {
            System.out.println("两个日期相等!");
            return L;
        }

        String tmp;
        if (date1.compareTo(date2) > 0) { // 确保 date1的日期不晚于date2
            tmp = date1;
            date1 = date2;
            date2 = tmp;
        }

        tmp = format.format(str2Date(date1).getTime() + 3600 * 24 * 1000);

        int num = 0;
        while (tmp.compareTo(date2) < 0) {
            L.add(tmp);
            num++;
            tmp = format.format(str2Date(tmp).getTime() + 3600 * 24 * 1000);
        }

        if (num == 0)
            System.out.println("两个日期相邻!");
        return L;
    }

    private static Date str2Date(String str) {
        if (str == null)
            return null;

        try {
            return format.parse(str);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 插入考勤组
     * @param rzry
     * @param groupId
     */
    private static void insertGroupMember(String rzry,String groupId){
        BaseBean bb  = new BaseBean();
        RecordSet rsInsert = new RecordSet();
        String sql = "insert into kq_groupmember (type,typevalue,groupid) "
                + " values(?,?,?) ";
        rsInsert.executeUpdate(sql, 1,rzry,groupId);
        bb.writeLog("insertSql:"+sql);
        new KQGroupMemberComInfo().removeCache();
    }


}


