package com.engine.leshanvc.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.leshanvc.service.EntryCommitFormModeService;
import com.engine.leshanvc.service.EntryWorkflowSaveEventService;
import com.engine.leshanvc.service.impl.EntryCommitFormModeServiceImpl;
import com.engine.leshanvc.service.impl.EntryWorkflowSaveEventServiceImpl;
import com.engine.leshanvc.util.ResponseResult;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @Author ml
 * @Date 2023/3/1 11:10
 * @Description This is description of class
 * @Since version-1.0
 */
public class EntryCommitFormModeController {

    public EntryCommitFormModeService getService(User user) {
        return ServiceUtil.getService(EntryCommitFormModeServiceImpl.class, user);
    }


    @POST
    @Path("/entryCommit")
    @Produces(MediaType.APPLICATION_JSON)
    public String entryCommit(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult<Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::entryCommit, ParamUtil.request2Map(request));
    }
}
