package com.engine.leshanvc.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.leshanvc.service.EntryWorkflowSaveEventService;
import com.engine.leshanvc.service.impl.EntryWorkflowSaveEventServiceImpl;
import com.engine.leshanvc.util.ResponseResult;
import lombok.extern.slf4j.Slf4j;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2023/2/21
 * @Version V1.0
 **/
@Slf4j
public class EntryWorkflowSaveEventAction {

    public EntryWorkflowSaveEventService getService(User user) {
        return ServiceUtil.getService(EntryWorkflowSaveEventServiceImpl.class, user);
    }


    @POST
    @Path("/changeStatus")
    @Produces(MediaType.APPLICATION_JSON)
    public String changeStatus(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult< Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::changeStatus, ParamUtil.request2Map(request));
    }

}
