package com.engine.leshanvc.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.leshanvc.service.SyncXcDataService;
import com.engine.leshanvc.service.WorkflowCheckService;
import com.engine.leshanvc.service.impl.SyncXcDataServiceImpl;
import com.engine.leshanvc.service.impl.WorkflowCheckServiceImpl;
import com.engine.leshanvc.util.ResponseResult;
import com.engine.organization.util.response.ReturnResult;
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.Map;

public class SyncXcDataAction {
    public SyncXcDataService getService(User user) {
        return ServiceUtil.getService(SyncXcDataServiceImpl.class,user);
    }
    @GET
    @Path("/syncXcData")
    @Produces(MediaType.APPLICATION_JSON)
    public String workflowController(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult<Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::syncXcData, ParamUtil.request2Map(request));
    }
    @GET
    @Path("/nonOfficeUpload")
    @Produces(MediaType.APPLICATION_JSON)
    public String nonOfficeUpload(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        User user = HrmUserVarify.getUser(request, response);
        return new ResponseResult<Map<String, Object>,  Map<String, Object>>(user).run(getService(user)::nonOfficeUpload, ParamUtil.request2Map(request));
    }

    @POST
    @Path("/saveIDCard")
    @Produces(MediaType.APPLICATION_JSON)
    public ReturnResult saveBaseComp(@Context HttpServletRequest request, @Context HttpServletResponse response, @RequestBody Map<String, Object> params) {
        try {
            User user = HrmUserVarify.getUser(request, response);
            return ReturnResult.successed(getService(user).saveIDCard(params));
        } catch (Exception e) {
            return ReturnResult.exceptionHandle(e);
        }
    }
}
