/**
 * BirthdayReminder Created on 2005-1-14 17:34:17
 * 
 * Copyright(c) 2001-2004 Weaver Software Corp.All rights reserved.
 */
package weaver.hrm.settings;

import java.io.IOException;
import java.util.*;

import com.cloudstore.dev.api.bean.MessageBean;
import com.cloudstore.dev.api.bean.MessageType;
import com.cloudstore.dev.api.util.Util_Message;
import com.engine.hrm.util.HrmTransMethod;

import com.engine.msgcenter.biz.ConfigManager;
import com.engine.msgcenter.biz.WeaMessageTypeConfig;
import com.google.common.collect.Sets;
import weaver.conn.RecordSet;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.appdetach.AppDetachComInfo;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.moduledetach.ManageDetachComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.workflow.msg.PoppupRemindInfoUtil;
/**
 * Description: BirthdayReminder
 * Company: 泛微软件
 *
 * @author xiaofeng.zhang
 * @version 1.0 2005-1-14
 */
/**
 * 生日提醒
 */
public class BirthdayReminder extends ChgPasswdReminder {
	private HashMap<String,String> htRecieverResource = new HashMap();
	public void remindAdministrator(int period)throws Exception
	{
    if (isSended(1))return;
		//提醒来源范围
    RecordSet rs = new RecordSet();
    String sql = " SELECT * FROM HrmBirthdayShare  ";
  	rs.executeSql(sql);
  	while(rs.next())
  	{
  		String sharetype = rs.getString("sharetype");
  		String relatedshare = "";//对象
  		String sharelevel = "";   //提醒级别
  		String seclevel = "";	//安全等级
  		String seclevelto = ""; //安全等级
  		String level = "0";    //角色或者岗位的级别
  		String org = "0";      //岗位指定的分部或者部门
  		String  lowerLevel  ="0" ; //包含下级
  		if(sharetype.equals("1")){
  			//人力资源
  			relatedshare = rs.getString("userid");
  		}else if(sharetype.equals("2")){
  			//分部
  			relatedshare = rs.getString("subcompanyid");
  			lowerLevel = rs.getString("lowerLevel");
  		}else if(sharetype.equals("3")){
  			//部门
  			relatedshare = rs.getString("departmentid");
  			lowerLevel = rs.getString("lowerLevel");
		}else if(sharetype.equals("4")){
				//角色
				relatedshare = rs.getString("roleid");
				level = rs.getString("rolelevel");
		}else if(sharetype.equals("7")){
				//岗位
				relatedshare = rs.getString("jobtitleid");
				level = rs.getString("jobtitlelevel");
				if(level.equals("1")) org = rs.getString("jobsubcompany");
				if(level.equals("2")) org = rs.getString("jobdepartment");
		}else if(sharetype.equals("5")){
				//所有人
				relatedshare = rs.getString("foralluser");
		}
  		if(sharetype.equals("1")){
  		}else{
  			seclevelto =  HrmTransMethod.getStringValue( rs.getString("seclevelto"),"100");
  			seclevel =  HrmTransMethod.getStringValue( rs.getString("seclevel"),"0");
  		}
  		sharelevel = rs.getString("sharelevel");
  		remindAdministrator(period, sharetype, relatedshare, sharelevel, seclevel, seclevelto,lowerLevel, level,org);
  	}
		//send message
		sendMessage(period);
	}
  /***
   * 提醒人力资源管理员
   * @param period
   * @param sharetype 提醒类别
   * @param relatedshare 对象
   * @param sharelevel 提醒来源范围
   * @param seclevel 对象安全级别
   * @throws Exception
   */
    public void remindAdministrator(int period, String sharetype, String relatedshare, String sharelevel, String seclevel, String seclevelto, String lowerLevel, String level, String org) throws Exception {
        //是否需要提醒
      	ChgPasswdReminder reminder=new ChgPasswdReminder();
      	RemindSettings settings=reminder.getRemindSettings();
      	if(!settings.getBirthvalidadmin().equals("1"))return;      
        String today = TimeUtil.getCurrentDateString();
        //ResourceComInfo rsComInfo = new ResourceComInfo();
        RecordSet recordset = new RecordSet();
        boolean isoracle = (recordset.getDBType()).equals("oracle");
        //查找生日要到了的员工
        String sql = " select * from HrmResource " 
        					 + " where (accounttype is null or accounttype=0) " 
        		             + " and (status = 0 or status = 1 or status = 2 or status = 3) " ;
        //增加提醒对象
		if (sharetype.equals("1")) {
			// 人力资源
			sql += " and id = " + relatedshare;
		} else if (sharetype.equals("2")) {
			// 分部
			sql += " and seclevel>=" + seclevel +"  and seclevel<=" + seclevelto;
			if(lowerLevel.equals("1"))//包含下级
			{
				sql+= " and   subcompanyid1 in ("+SubCompanyComInfo.getAllChildSubcompanyId(relatedshare,relatedshare)+")" ;				
			}else{
				sql+= " and  subcompanyid1 = " + relatedshare ;
			}
		} else if (sharetype.equals("3")) {
			// 部门
			sql += " and seclevel>=" + seclevel +"  and seclevel<=" + seclevelto;
			if(lowerLevel.equals("1"))//包含下级
			{
				sql+= " and   departmentid in ("+DepartmentComInfo.getAllChildDepartId(relatedshare, relatedshare)+")" ;				
			}else{
				sql+= " and  departmentid = " + relatedshare ;
			}
		} else if (sharetype.equals("4")) {
			// 角色
			//sql+= "  and id in ( select resourceid from HrmRoleMembers where roleid=" + relatedshare + " and rolelevel>="+level+")"+" and seclevel>=" + seclevel +" and seclevel<=" + seclevelto;
			String roleSql = " SELECT distinct resourceid FROM ( "+
			" SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
			" WHERE (a.id=b.resourceid and b.resourcetype=1) "+
			" UNION ALL "+
			" SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResourceManager a, HrmRoleMembers b "+
			" WHERE (a.id=b.resourceid and b.resourcetype IN(7,8)) "+
			" UNION ALL "+
			" SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
			" WHERE (a.subcompanyid1 = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=2) "+
			" UNION ALL "+
			" SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
			" WHERE (a.departmentid = b.resourceid AND a.seclevel>=b.seclevelfrom AND a.seclevel<=b.seclevelto AND b.resourcetype=3) "+
			" UNION ALL "+
			" SELECT a.id AS resourceid, b.roleid , b.rolelevel FROM HrmResource a, HrmRoleMembers b "+
			" WHERE  (a.jobtitle = b.resourceid AND b.resourcetype=5 AND (b.jobtitlelevel=1 OR (b.jobtitlelevel=2 AND a.subcompanyid1 IN(b.subdepid)) OR (b.jobtitlelevel=3 AND a.departmentid IN(b.subdepid))))) t "+
			" WHERE roleid=" + relatedshare + " and rolelevel>="+level+" ";
			sql+= "  and id in ("+roleSql+")"+" and seclevel>=" + seclevel +" and seclevel<=" + seclevelto;
		} else if (sharetype.equals("7")) {
			// 岗位
			sql+= " and jobtitle = "+relatedshare+" "+"  and seclevel>=" + seclevel +"  and  seclevel<=" + seclevelto;
			if(level.equals("1")){
				sql+= " and  subcompanyid1= " + org ;
			}else if(level.equals("2")){
				sql+= " and  departmentid = " + org ;
			}
		} else if (sharetype.equals("5")) {
			// 所有人 
			sql += " and seclevel>=" + seclevel +"and seclevel<=" + seclevelto;
		}
        recordset.executeSql(sql);
        String year1 = today.substring(0, 4);
        String year2 = TimeUtil.dateAdd(today, period).substring(0, 4);
		RecordSet recordset1 = new RecordSet();
        ArrayList remindedResourceList = getRemindedResourceid(period);
        while (recordset.next()) {
        	String hrm = recordset.getString("id");
			String subId = recordset.getString("subcompanyid1"); 
			String depId = recordset.getString("departmentid");
			// 基准是对象，先获取所有的对象，然后根据对象的
			// 查找生日要到了的员工
			sql = " select * from HrmResource "
					+ " where (accounttype is null or accounttype=0) "
					+ " and (status = 0 or status = 1 or status = 2 or status = 3) "
					 + " and birthday is not null";
	        if(!isoracle) sql+=" and birthday<>''";
			// 增加提醒来源范围
			if (sharelevel.equals("0")) {
				// 本部门 指的是和当前对象相同部门的对象
				sql += " and HrmResource.departmentid = " + depId;
			} else if (sharelevel.equals("1")) {
				// 本部门及上级部门
				sql += " and exists ( select * from hrmdepartment where HrmResource.departmentid= hrmdepartment.id "
						+ " and hrmdepartment.id in ("
						+ DepartmentComInfo.getAllParentDepartId(depId, depId)
						+ "))";
			} else if (sharelevel.equals("2")) {
				// 本部门及下级部门
				sql += " and exists ( select * from hrmdepartment where HrmResource.departmentid= hrmdepartment.id "
						+ " and hrmdepartment.id in ("
						+ DepartmentComInfo.getAllChildDepartId(depId, depId)
						+ "))";
			} else if (sharelevel.equals("3")) {
				// 本分部
				sql += " and HrmResource.subcompanyid1 = " + subId;
			} else if (sharelevel.equals("4")) {
				// 本分部及上级分部
				sql += " and exists ( select * from HrmSubCompany where HrmResource.subcompanyid1= HrmSubCompany.id "
						+ " and HrmSubCompany.id in ("
						+ SubCompanyComInfo.getAllParentSubcompanyId(subId,
								subId) + "))";
			} else if (sharelevel.equals("5")) {
				// 本分部及下级分部
				sql += " and exists ( select * from HrmSubCompany where HrmResource.subcompanyid1= HrmSubCompany.id "
						+ " and HrmSubCompany.id in ("
						+ SubCompanyComInfo.getAllChildSubcompanyId(subId,subId) + "))";
			}
			recordset1.executeSql(sql);
	        String resourceids = "";
			while (recordset1.next()) {
	            String id = recordset1.getString("id");
	            if (remindedResourceList.indexOf(id) > -1)
	                continue;
	            String birthday = recordset1.getString("birthday");
	            if(birthday == null||birthday.length()<10||birthday.indexOf("-")<=0){
	          		continue;		
	             }
	            if (year1.equals(year2)) {
	                birthday = year1 + birthday.substring(4);
	                if (TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) >= 0 && TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) <= period) {
	                		if(resourceids.length()>0)resourceids+=",";
	                		resourceids+=id;
	                }
	            } else {
	                birthday = year1 + birthday.substring(4);
	                if (TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) >= 0 && TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) <= period) {
		              		if(resourceids.length()>0)resourceids+=",";
		              		resourceids+=id;
	                }
	                birthday = year2 + birthday.substring(4);
	                if (TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) >= 0 && TimeUtil.dateInterval(birthday, TimeUtil.dateAdd(today, period)) <= period) {
		              		if(resourceids.length()>0)resourceids+=",";
		              		resourceids+=id;
	                }
	            }
			}
          	if(htRecieverResource.get(hrm)==null){
//          		System.err.println("_1 _hrm---"+hrm+"______resourceids---"+resourceids+"_________");
          		htRecieverResource.put(hrm, resourceids);
          	}else{
          		String tmpresourceids = htRecieverResource.get(hrm);
          		if(tmpresourceids.length()>0)tmpresourceids+=",";
          		tmpresourceids+=resourceids;
//          		System.err.println("_2 _hrm---"+hrm+"______resourceids---"+resourceids+"_________");
          		htRecieverResource.put(hrm, resourceids);
          	}
        }
    }
    public void sendMessage(int period)throws Exception{
    	ResourceComInfo rsComInfo = new ResourceComInfo();
    	for (String receiver : htRecieverResource.keySet()) {
    		String resourceids=(String)htRecieverResource.get(receiver);
        StringBuffer title = new StringBuffer();
        StringBuffer remark = new StringBuffer();
    		if(resourceids.length()>0){
	    		List ls = Util.TokenizerString(resourceids, ",");
	    		Map<String, String> idMap = new LinkedHashMap<String, String>();
	    		for(Object resourceid : ls){
	    			String id = (String)resourceid;
	    			String birStatus = rsComInfo.getStatus(id);
	    			if(!"0".equals(birStatus) && !"1".equals(birStatus) && !"2".equals(birStatus) && !"3".equals(birStatus)) {
	    				continue;
					}
		    		if(!idMap.containsKey(id)) {
		    			idMap.put(id, id);
			    		String name = rsComInfo.getResourcename(id);
				      	ArrayList remindedResourceList = getRemindedResourceid(period);
			    		//记录历史信息
			    		if(!(remindedResourceList.indexOf(id)>-1))recordAdminRemindHistory(id);
			    		title.append(name);
			    		title.append(" ");
			    		remark.append("<a href='javascript:openhrm(" + id + ");' onclick='pointerXY(event);'>" + name + "</a>&nbsp;");
		    		}
	    		}
	        String str_title = title.toString() + ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003683,weaver.general.ThreadVarLanguage.getLang())+"";
	        sendMsg(str_title, 1, receiver, remark.toString());
    		}
    	}
    }
    
    
    
    
    public  Map<String, String>  removeRepeat(Map<String, String> map ,String key_orgId ,String birth_userid ) {
	     boolean  isHas = map.containsKey(key_orgId);
	     if(key_orgId.length()==0) return map;
	     if(isHas){
	         birth_userid = map.get(key_orgId)+","+birth_userid;
	         map.put(key_orgId, birth_userid);
	     }else{
	    	  map.put(key_orgId, birth_userid);
	     }
		 return map;
	}
    
     /**
     * 【员工提醒】消息中心
     * @param congratulation  祝词
     * @param token  替换祝词中的符号
     * @throws Exception
     */
    @SuppressWarnings("deprecation")
	public void remindEmployer(String congratulation, String token) throws Exception {
		//判断今天是否已经推送过
		if (isSended(2)) {
			return;
		}

		String today = TimeUtil.getCurrentDateString();
		String year = today.substring(0, 4);
		ResourceComInfo rsComInfo = new ResourceComInfo();
		DepartmentComInfo departmentComInfo = new DepartmentComInfo();
		SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();

		RecordSet recordset = new RecordSet();
		boolean isoracle = (recordset.getDBType()).equals("oracle");
		Map<String, String> dataMap = new HashMap<String, String>();

		//判断提醒范围
		ChgPasswdReminder reminder = new ChgPasswdReminder();
		RemindSettings settings = reminder.getRemindSettings();
		String brithalarmscope = settings.getBrithalarmscope();//提醒范围
		String birthshowfieldWF = settings.getBirthshowfieldWF();//消息中心方式的显示字段
		String congratulation1 = settings.getCongratulation1();//消息中心方式的生日祝词
		//1-本人、2-同部门、4-同分部、5-同部门以及上级部门、6-同部门以及下级部门、7-同分部以及上级分部、8-同分部以及下级分部、3-所有人
		int scope = Integer.parseInt(brithalarmscope);
		String birth_userid = "";
		//根据范围查找要过生日的人
		if (brithalarmscope.equals("1")) {
			//本人
			String sql = "select id,birthday from HrmResource where (accounttype is null or accounttype=0) and  (status = 0 or status = 1 or status = 2 or status = 3) and birthday is not null";
			if (!isoracle) sql += " and birthday<>''";
			recordset.executeSql(sql);
			while (recordset.next()) {
				String id = recordset.getString("id");
				String birthday = recordset.getString("birthday");
				if (birthday == null || birthday.length() < 10 || birthday.indexOf("-") <= 0) {
					continue;
				}
				birthday = year + birthday.substring(4);
				if (TimeUtil.dateInterval(birthday, today) == 0) {
					dataMap.put(id, id);
				}
			}
		} else if (scope == 2 || scope == 5 || scope == 6) {    //本部门  以上及以下部门
			String sql = "select distinct departmentid, birthday,id from HrmResource where (accounttype is null or accounttype=0) and  (status = 0 or status = 1 or status = 2 or status = 3) and birthday is not null";
			if (!isoracle) sql += " and birthday<>''";
			recordset.executeSql(sql);
			String departmentid = "";
			while (recordset.next()) {
				birth_userid = recordset.getString("id");
				departmentid = Util.null2String(recordset.getString("departmentid"));
				if (departmentid.length() == 0) continue;
				String birthday = recordset.getString("birthday");
				if (birthday == null || birthday.length() < 10 || birthday.indexOf("-") <= 0) {
					continue;
				}
				birthday = year + birthday.substring(4);
				if (TimeUtil.dateInterval(birthday, today) == 0) {
					if (scope == 2) dataMap = removeRepeat(dataMap, departmentid, birth_userid);
					if (scope == 5) {
						String[] deptStrings = DepartmentComInfo.getAllParentDepartId(departmentid, departmentid).split(",");
						for (String str : deptStrings) {
							dataMap = removeRepeat(dataMap, str, birth_userid);
						}
					}
					if (scope == 6) {
						String[] deptStrings = DepartmentComInfo.getAllChildDepartId(departmentid, departmentid).split(",");
						for (String str : deptStrings) {
							dataMap = removeRepeat(dataMap, str, birth_userid);
						}
					}
				}
			}
		} else if (scope == 4 || scope == 7 || scope == 8) {//本分部  以上及以下分部

			String sql = "select distinct subcompanyid1, birthday ,id from HrmResource where (accounttype is null or accounttype=0) and  (status = 0 or status = 1 or status = 2 or status = 3) and birthday is not null";
			if (!isoracle) sql += " and birthday<>''";
			recordset.executeSql(sql);
			String subcompanyid1 = "";
			while (recordset.next()) {
				birth_userid = recordset.getString("id");
				subcompanyid1 = Util.null2String(recordset.getString("subcompanyid1"));
				if (subcompanyid1.length() == 0) continue;
				String birthday = recordset.getString("birthday");
				if (birthday == null || birthday.length() < 10 || birthday.indexOf("-") <= 0) {
					continue;
				}

				birthday = year + birthday.substring(4);
				if (TimeUtil.dateInterval(birthday, today) == 0) {
					if (scope == 4) dataMap = removeRepeat(dataMap, subcompanyid1, birth_userid);
					if (scope == 7) {
						String[] subcStrings = SubCompanyComInfo.getAllParentSubcompanyId(subcompanyid1, subcompanyid1).split(",");
						for (String str : subcStrings) {
							dataMap = removeRepeat(dataMap, str, birth_userid);
						}
					}
					if (scope == 8) {
						String[] subcStrings = SubCompanyComInfo.getAllChildSubcompanyId(subcompanyid1, subcompanyid1).split(",");
						for (String str : subcStrings) {
							dataMap = removeRepeat(dataMap, str, birth_userid);
						}
					}
				}
			}
		} else if (brithalarmscope.equals("3")) {
			String sql = "select id,birthday from HrmResource where (accounttype is null or accounttype=0) and  (status = 0 or status = 1 or status = 2 or status = 3) and birthday is not null";
			if (!isoracle) sql += " and birthday<>''";
			recordset.executeSql(sql);
			StringBuffer birth_Userid = new StringBuffer();  //所有生日人员的userID
			while (recordset.next()) {
				String birthday = recordset.getString("birthday");
				if (birthday == null || birthday.length() < 10 || birthday.indexOf("-") <= 0) {
					continue;
				}
				birthday = year + birthday.substring(4);
				if (TimeUtil.dateInterval(birthday, today) == 0) {
					if (birth_Userid.length() != 0) birth_Userid.append("," + recordset.getString("id"));
					else birth_Userid.append(recordset.getString("id"));
				}
			}
			if (!birth_Userid.toString().equals("")) {
				dataMap.put(birth_Userid.toString(), birth_Userid.toString());
			}
		}
		Set keys = dataMap.keySet();
		if (keys != null) {
			Iterator iterator = keys.iterator();
			StringBuffer title = new StringBuffer();
			StringBuffer remark = new StringBuffer();
			String key = "";
			String value = "";
			while (iterator.hasNext()) {
				title = new StringBuffer();
				remark = new StringBuffer();
				key = (String) iterator.next();
				value = dataMap.get(key);
				if (value == null || value.equals("")) {
					continue;
				}
				String[] valueArr = value.split(",");
				for (int i = 0; i < valueArr.length; i++) {
					String userid = valueArr[i];
					String name = rsComInfo.getResourcename(userid);
					title.append(name);
					if (birthshowfieldWF.indexOf("2") > -1) {
						String departmentName = departmentComInfo.getDepartmentName(rsComInfo.getDepartmentID(userid));
						title.append("-").append(departmentName);
					}
					if (birthshowfieldWF.indexOf("3") > -1) {
						String subcompanyName = subCompanyComInfo.getSubcompanyname(rsComInfo.getSubCompanyID(userid));
						title.append("-").append(subcompanyName);
					}
					if (i != valueArr.length - 1) {
						title.append("，");
					}
				}
				remark.append(value);
				if (!title.toString().trim().equals("")) {
					Set<String> resourceIdList = new HashSet<String>();
					//查找所有员工
					String sql = "select id from HrmResource where (accounttype is null or accounttype=0) and (status = 0 or status = 1 or status = 2 or status = 3)";
					if (brithalarmscope.equals("1")) {//本人
						sql += " and id=" + key;
					} else if (brithalarmscope.equals("2") || brithalarmscope.equals("5") || brithalarmscope.equals("6")) { //本部门  以下及以下部门
						sql += "  and departmentid  =  " + key + " ";
					} else if (brithalarmscope.equals("4") || brithalarmscope.equals("7") || brithalarmscope.equals("8")) { //本分部 以下及以下分部
						sql += " and subcompanyid1 = " + key + " ";
					} else if (brithalarmscope.equals("3")) {
						//所有人
					}
					recordset.executeSql(sql);
					while (recordset.next()) {
						resourceIdList.add(recordset.getString("id"));
					}

					String str_title = title + ""+weaver.systeminfo.SystemEnv.getHtmlLabelName(10003684,weaver.general.ThreadVarLanguage.getLang())+"" + congratulation;
					sql = "insert into HrmBirthRemindMsg(title,resources,reminddate) values('" + str_title + "','" + remark.toString() + "','" + today + "')";
					recordset.executeUpdate(sql);

					//记录发送历史
					recordEmployerRemindHistory();

					//消息提醒
					String content = congratulation1.replace("$", " " + title.toString() + " ");
					String linkUrl = ""; //PC端链接
					String linkMobileUrl = ""; //移动端链接
					try {
						MessageBean messageBean = Util_Message.createMessage(MessageType.HR_BIRTHDAY_REMIND, resourceIdList, content, content, linkUrl, linkMobileUrl);
						messageBean.setCreater(1);//创建人id
						Util_Message.store(messageBean);
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}
	}
 


	public ArrayList<String[]> getBirthEmployerNames(User user) {

		ArrayList<String[]> birthEmployers = new ArrayList<String[]>();
		String[] birthEmployer = null; //部门 机构 姓名

		//判断提醒范围
		ChgPasswdReminder reminder = new ChgPasswdReminder();
		RemindSettings settings = reminder.getRemindSettings();
		String brithalarmscope = settings.getBrithalarmscope();//提醒范围

		try {

			AppDetachComInfo adci = new AppDetachComInfo();

			String today = TimeUtil.getCurrentDateString();
			ResourceComInfo rsComInfo = new ResourceComInfo();
			SubCompanyComInfo subComInfo = new SubCompanyComInfo();
			DepartmentComInfo departComInfo = new DepartmentComInfo();
			String year = today.substring(0, 4);
			String monthDays = today.substring(4,10);
			RecordSet recordset = new RecordSet();
			//查找生日要到了的员工
			//modify by Ds 生日提醒不显示次账号数据

			String sql = "select id,subcompanyid1,departmentid,birthday from HrmResource where (accounttype is null or accounttype=0) and (status = 0 or status = 1 or status = 2 or status = 3) and birthday like '%" + monthDays + "'";
			recordset.executeQuery(sql);

			while (recordset.next()) {
				String id = recordset.getString("id");
				String departmentid = recordset.getString("departmentid");
				String subcompanyid1 = recordset.getString("subcompanyid1");
				if (brithalarmscope.equals("1")) {
					//本人
					if(!id.equals(user.getUID())){
						continue;
					}
				} else if (brithalarmscope.equals("2") || brithalarmscope.equals("5") || brithalarmscope.equals("6")) {
					//本部门 及以上和 以及部门
					String depId = user.getUserDepartment() + "";
					depId = brithalarmscope.equals("2") ? depId : (brithalarmscope.equals("6") ? DepartmentComInfo.getAllParentDepartId(depId, depId) : DepartmentComInfo.getAllChildDepartId(depId, depId));
					if((","+depId+",").indexOf(","+departmentid+",")==-1){
						continue;
					}
				} else if (brithalarmscope.equals("4") || brithalarmscope.equals("7") || brithalarmscope.equals("8")) {
					//本部  及以上和 以及下分部
					String subId = user.getUserSubCompany1() + "";
					subId = brithalarmscope.equals("4") ? subId : (brithalarmscope.equals("8") ? SubCompanyComInfo.getAllParentSubcompanyId(subId, subId) : SubCompanyComInfo.getAllChildSubcompanyId(subId, subId));
					if((","+subId+",").indexOf(","+subcompanyid1+",")==-1){
						continue;
					}
				} else if (brithalarmscope.equals("3")) {
					//所有人 无需处理
				}
				if(adci.isUseAppDetach()){
					boolean hasPower = adci.isAllDetachResourceInfo( user,id,departmentid,subcompanyid1);
					if (!hasPower) {
						continue;
					}
				}

//                String birthday = recordset.getString("birthday");

				//检查birthday格式是否非法Begin
//            	if(birthday == null||birthday.length()<10||birthday.indexOf("-")<=0){
//            		continue;
//            	}

//               String birthdayN = year+birthday.substring(4,10);

//                if (birthdayN.equals(today)) {//modifer by lvyi 2014-10-24
				birthEmployer = new String[4];
				String name = rsComInfo.getResourcename(id);
				String com_name = subComInfo.getSubCompanyname(subcompanyid1);
				String department_name = departComInfo.getDepartmentname(departmentid);
				birthEmployer[0] = name;
				birthEmployer[1] = com_name;
				birthEmployer[2] = department_name;
				birthEmployer[3] = id;

				birthEmployers.add(birthEmployer);
//                }
			}
		} catch (Exception ex) {
			new weaver.general.BaseBean().writeLog("员工生日格式错误! ex=" + ex);
		}

		return birthEmployers;
	}

    private boolean isSended(int type) {
        String today = TimeUtil.getCurrentDateString();
        String sql = "select * from HrmRemindHistory where type=" + type + " and reminddate='" + today + "'";
        RecordSet recordset = new RecordSet();
        recordset.executeSql(sql);

        if (recordset.next())
            return true;
        else
            return false;

    }

    private ArrayList getRemindedResourceid(int period) {
        ArrayList remindedResourceList = new ArrayList();
        String today = TimeUtil.getCurrentDateString();
        String sql = "select remindedresourceid from HrmRemindHistory where reminddate>='" + TimeUtil.dateAdd(today, -period) + "'";
        RecordSet recordset = new RecordSet();
        recordset.executeSql(sql);
        while (recordset.next()) {
            String remindedresourceid = recordset.getString("remindedresourceid");
            remindedResourceList.add(remindedresourceid);

        }
        return remindedResourceList;
    }

    private void recordAdminRemindHistory(String resourceid) {
        String today = TimeUtil.getCurrentDateString();
        String sql = "insert into HrmRemindHistory (type,reminddate,remindedresourceid) values(" + 1 + ",'" + today + "'," + resourceid + ")";
        RecordSet recordset = new RecordSet();
        recordset.executeSql(sql);
    }

    private void recordEmployerRemindHistory() {
        String today = TimeUtil.getCurrentDateString();
        String sql = "insert into HrmRemindHistory (type,reminddate,remindedresourceid) values(" + 2 + ",'" + today + "',null)";
        RecordSet recordset = new RecordSet();
        recordset.executeSql(sql);
    }

    /**
     * @param period
     * @throws Exception
     * @deprecated
     */
    public void remind(int period) throws Exception {
        //do nothing
        return;
    }
    
}