package weaver.interfaces.hansang.action;

import com.engine.kq.biz.KQFormatData;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.Calendar;

/**
 * @author wanxq
 * @date 2023年10月16日14:47:20
 * @desc 刷新考勤报表数据
 */
public class RefreshKqReportAction extends BaseBean implements Action {


    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        String tableName = requestInfo.getRequestManager().getBillTableName();

        try {
            RecordSet rs = new RecordSet();

            String sql = " select resourceId,fromDate,fromTime,toDate,toTime from "+tableName+" where requestid=? ";
            rs.executeQuery(sql,requestid);
            if(rs.next()){
                String resourceId = Util.null2String(rs.getString("resourceId"));
                String fromDate = Util.null2String(rs.getString("fromDate"));
                String toDate = Util.null2String(rs.getString("toDate"));

                KQFormatData kqFormatData = new KQFormatData();
                Calendar cal = DateUtil.getCalendar();
                boolean isEnd = false;
                for (String date = fromDate; !isEnd; ) {
                    if (date.equals(toDate)) {
                        isEnd = true;
                    }
                    kqFormatData.formatKqDate(resourceId, date);
                    cal.setTime(DateUtil.parseToDate(date));
                    date = DateUtil.getDate(cal.getTime(), 1);
                }
            }
        }catch (Exception e){
            requestInfo.getRequestManager().setMessageid("10009");
            requestInfo.getRequestManager().setMessagecontent("考勤报表数据刷新错误");
            return FAILURE_AND_CONTINUE;
        }
        return SUCCESS;
    }







}
