package weaver.interfaces.hansang.job;


import com.weaver.formmodel.util.DateHelper;
import org.apache.commons.lang.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年10月10日10:00:34
 * @desc
 */
public class AnnualLeaveBaseCalculateJob extends BaseCronJob {
    private String selectMonth;

    public String getSelectMonth() {
        return selectMonth;
    }

    public void setSelectMonth(String selectMonth) {
        this.selectMonth = selectMonth;
    }

    @Override
    public void execute() {
        if(StringUtils.isBlank(selectMonth)){
            selectMonth = DateHelper.getCurrentMonth();
        }

        String currentYear = DateHelper.getCurrentYear();
        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();
        String sql = " select a.id,lastname,workyear,companystartdate,field82,baseamount from hrmresource a " +
                "   left join cus_fielddata b on a.id=b.id and b.scopeid=3 " +
                "   left join kq_balanceOfLeave c on a.id = c.resourceId " +
                "   where field82 like '"+selectMonth+"%' and leaveRulesId=-6 and belongYear='"+currentYear+"' and baseamount>0 ";
        rs.executeQuery(sql);
        while(rs.next()){
            String userid = Util.null2String(rs.getString("id"));
            double workyear = Util.getDoubleValue(rs.getString("workyear"),0);
            String companystartdate = Util.null2String(rs.getString("companystartdate"));
            String field82 = Util.null2String(rs.getString("field82"));

            double baseAmount = 0;
            if(workyear>=1 && workyear<10){
                baseAmount = 40.0;
            }

            if(workyear>=10 && workyear<20){
                baseAmount = 80.0;
            }

            if(workyear>=20){
                baseAmount = 120.0;
            }

            int diffDays = DateUtil.dayDiff(field82,currentYear+"-01-01");
            if(companystartdate.length()>4 && currentYear.equals(companystartdate.substring(0,4))){
                diffDays =  DateUtil.dayDiff(field82,companystartdate);
            }


            double realBaseAmount = diffDays*baseAmount/365;
            int integerPart = (int)realBaseAmount;
            double decimalPart = realBaseAmount-integerPart;

            if(decimalPart<0.5){
                realBaseAmount = (double) integerPart;
            }else{
                realBaseAmount = integerPart+0.5;
            }
            String updateSql = " update kq_balanceOfLeave set baseamount=? where resourceId=? and leaveRulesId=-6 and belongYear=? ";
            rs2.executeUpdate(updateSql,realBaseAmount,userid,currentYear);

        }

    }



}
