package weaver.interfaces.hansang.job;


import weaver.conn.RecordSet;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年07月05日08:59:23
 * @desc
 */
public class HrmGroupMemberSyn extends BaseCronJob {


    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();
        String sql = " select xc,xnfzbm,xnfzmc from uf_xlfz  where xc is not null  ";
        rs.execute(sql);
        while(rs.next()){
            String xc = Util.null2String(rs.getString("xc"));
            String xnfzbm = Util.null2String(rs.getString("xnfzbm"));
            String xnfzmc = Util.null2String(rs.getString("xnfzmc"));

            //判断私人组是否存在
            String groupName = "XLFZ"+xnfzbm+"-"+xnfzmc;
            String groupid = "";
            String groupSql = " select id from hrmgroup where name='"+groupName+"' and type=0 and owner="+xc+" and (canceled is null or canceled='') ";

            rs2.executeQuery(groupSql);
            if(rs2.next()){
                groupid = Util.null2String(rs2.getString("id"));
            }else{
                rs2.executeUpdate(" insert into hrmgroup(name,type,owner,sn) values(?,0,?,0.00)",groupName,xc);
                rs2.executeQuery(groupSql);

                if(rs2.next()){
                    groupid = Util.null2String(rs2.getString("id"));
                }
            }

            if("".equals(groupid)){
                System.out.println("HrmGroupMemberSyn groupSql===>"+groupSql);
            }else{
                //处理私人组中的成员
                handleGroupMembers(groupid,xc);
            }



        }
    }

    /**
     * 处理私有组成员
     * @param groupid
     * @param xc
     */
    public void handleGroupMembers(String groupid,String xc) {
        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();
        String sql = " select id from cus_fielddata where field89=? ";
        rs.executeQuery(sql,xc);
        while(rs.next()){
            String memberid = Util.null2String(rs.getString("id"));

            rs2.executeUpdate(" delete from hrmgroupmembers where id in ( select id from (select b.id \n" +
                    "from hrmgroup a,hrmgroupmembers b \n" +
                    "where a.id=b.groupid and a.name like 'XLFZ%' and b.userid=? and b.groupid!=?) as temp)",memberid,groupid);

            if(!isInGroup(memberid,groupid)){
                rs2.executeUpdate(" insert into hrmgroupmembers(groupid,userid,usertype,dsporder) values(?,?,0,0) ",groupid,memberid);
            }


        }

    }

    /**
     * 判断人员是否在私有组中
     * @param userid
     * @param groupid
     * @return
     */
    public boolean isInGroup(String userid,String groupid){
        RecordSet rs = new RecordSet();
        rs.executeQuery("select * from hrmgroupmembers where userid=? and groupid=? ",userid,groupid);
        return rs.next();
    }

    public static void main(String[] args) {
        System.out.println(TimeUtil.getCurrentDateString());
    }


}
