package weaver.interfaces.hansang.job;


import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cloudstore.dev.api.util.Util_DataCache;
import com.engine.kq.biz.KQFormatBiz;
import com.engine.kq.timer.KQQueue;
import com.engine.kq.timer.KQTaskBean;
import com.engine.kq.wfset.util.SplitActionUtil;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import org.apache.commons.lang.StringUtils;
import weaver.common.DateUtil;
import weaver.conn.BatchRecordSet;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @author wanxq
 * @date 2023年06月20日09:25:14
 * @desc
 */
public class KqGroupMemberSyn extends BaseCronJob {


    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();
        String currentDate = TimeUtil.getCurrentDateString();
        String sql = " select id,field103,field104 from cus_fielddata  where field104 is not null and  field103=?  ";
        System.out.println("KqGroupMemberSyn===>"+sql+"  "+currentDate);
        rs.executeQuery(sql,currentDate);
        while(rs.next()){
            String id = Util.null2String(rs.getString("id"));
            String groupid = Util.null2String(rs.getString("field104"));

            if(!isInKqGroup(id,groupid)){
                String insertSql = " insert into kq_groupmember(type,typevalue,groupid) values(?,?,?)";
                System.out.println("KqGroupMemberSyn insertSql===>"+insertSql);
                rs2.executeUpdate(insertSql,1,id,groupid);
            }else{
                String updateSql = " update kq_groupmember set isdelete=null where typevalue=? and groupid=? ";
                System.out.println("KqGroupMemberSyn updateSql===>"+updateSql);
                rs2.executeUpdate(updateSql,id,groupid);
            }
        }
    }

    /**
     * 判断人员是否在考勤组中
     * @param id
     * @param groupid
     * @return
     */
    public boolean isInKqGroup(String id,String groupid){
        RecordSet rs = new RecordSet();
        String sql = "select * from kq_groupmember where typevalue=? and groupid=? ";
        System.out.println("isInKqGroup===>"+sql+"  "+id+"  "+groupid);
        rs.executeQuery(sql,id,groupid);
        return rs.next();
    }

    public static void main(String[] args) {
        System.out.println(TimeUtil.getCurrentDateString());
    }


}
