package weaver.interfaces.hansang.job;


import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年07月31日17:24:18
 * @desc 定时将外勤打卡人员同步到角色中
 */
public class OutSignUserSynJob extends BaseCronJob {


    @Override
    public void execute() {


        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();
        String sql = "  select id from hrmroles where  rolesmark='外勤打卡人员'  ";
        rs.execute(sql);
        if(rs.next()){
            String roleid = Util.null2String(rs.getString("id"));

            //从角色中删除已经不是外勤打卡的人员
            String deleteSql = " delete from hrmrolemembers where roleid=? " +
                    "     and resourceid in(  " +
                    "     select id from ( " +
                    "     select id from cus_fielddata cf where (field37!=1 or field37 is null) and scope='HrmCustomFieldByInfoType' and scopeid=-1 " +
                    "     and exists (select 1 from hrmrolemembers hr where hr.roleid=? and resourceid=cf.id) )t " +
                    "     )";
            rs.executeUpdate(deleteSql,roleid,roleid);

            //同步需要外勤打卡的人员
            String synSql = " select id from cus_fielddata cf where field37=1 " +
                    "   and not exists ( select 1 from hrmrolemembers hr where hr.roleid=? and resourceid=cf.id)";
            rs.executeQuery(synSql,roleid);
            while(rs.next()){
                String userid = Util.null2String(rs.getString("id"));

                String insertSql = " insert into hrmrolemembers(roleid,resourceid,rolelevel,resourcetype) values(?,?,?,?) ";
                rs2.executeUpdate(insertSql,new Object[]{roleid,userid,2,1});
            }
        }
    }


}
