package weaver.interfaces.hansang.job;


import com.engine.kq.biz.KQAttFlowSetBiz;
import com.engine.kq.biz.KQFlowActiontBiz;
import com.engine.kq.enums.KqSplitFlowTypeEnum;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.HashMap;
import java.util.Map;

/**
 * @author wanxq
 * @date 2023年08月17日14:17:51
 * @desc
 */
public class OvertimeCalculateJob extends BaseCronJob {

    @Override
    public void execute() {

        // 如果是出差没有刷新报表，可以通过下面的连接批量处理
        String fromDate = DateUtil.getYesterday();
        String toDate = fromDate;
        doCalculate(fromDate,toDate,"","");

    }


    public void doCalculate(String fromDate,String toDate,String resourceid,String isForce){
        boolean isForce1 = false;
        boolean isUpgrade1 = false;
        User user = new User(1);
        KQAttFlowSetBiz kqAttFlowSetBiz = new KQAttFlowSetBiz();
        KQFlowActiontBiz kqFlowActiontBiz = new KQFlowActiontBiz();
        Map<String, Object> params = new HashMap<>();
        params.put("typeselect", "6");
        params.put("tabKey", "3");
        params.put("kqtype", 3);
        params.put("isMyKQ", "1");
        params.put("isNoAccount", "1");
        params.put("fromDate", fromDate);
        params.put("toDate", toDate);
        params.put("not_start_node", "1");
        if(resourceid.length()>0){
            params.put("resourceId", resourceid);
        }
        if(isForce.length()>0 && "true".equals(isForce)){
            isForce1 = true;
        }

        Map<String,String> sqlMap = kqAttFlowSetBiz.getFLowSql(params,user);
        String backfields = "  * ";
        String fromSql  = Util.null2String(sqlMap.get("from"));
        String sqlWhere = Util.null2String(sqlMap.get("where"));
        String allSql = "select "+ backfields + fromSql+sqlWhere;
        RecordSet rs = new RecordSet();
        RecordSet rs1 = new RecordSet();
        rs.writeLog("allSql:" + allSql + "<br/>");
        rs.executeQuery(allSql);
        Map<String, String> infoMap = new HashMap<>();
        while (rs.next()) {
            String currentnodetype = rs.getString("currentnodetype");
            if(!"3".equals(currentnodetype)) {
                continue;
            }
            String requestId = rs.getString("requestid");
            String workflowId = rs.getString("workflowid");
            infoMap.put(requestId, workflowId);
        }
        rs.writeLog("infoMap:" + infoMap.toString() + "<br/>");
        for(Map.Entry<String, String> entry : infoMap.entrySet()) {
            String requestid = entry.getKey();
            String workflowid = entry.getValue();
            //先根据requestid删除中间表里的数据，再做啥插入操作
            String delSql = "delete from "+ KqSplitFlowTypeEnum.OVERTIME.getTablename()+" where requestid = "+requestid;
            rs.executeUpdate(delSql);

            //加班有两个表
            delSql = "delete from kq_flow_overtime where requestid = "+requestid;
//		out.println("先删除中间表数据 : " + delSql+"<br/>");
            rs1.executeUpdate(delSql);


            String proc_set_sql = "select * from kq_att_proc_set where field001 = ?  ";
            rs.executeQuery(proc_set_sql, workflowid);
            if(rs.next()) {
                String proc_set_id = rs.getString("id");
                //得到这个考勤流程设置是否使用明细
                String usedetails = rs.getString("usedetail");

                int kqtype = Util.getIntValue(rs.getString("field006"));

                Map<String, String> map = new HashMap<String, String>();
                if (Util.getIntValue(requestid) > 0) {
                    map.put("requestId", "and t.requestId = " + requestid);
                }

                try {
                    Map<String, String> result = kqFlowActiontBiz.handleKQFlowAction(proc_set_id, usedetails, Util.getIntValue(requestid), kqtype,
                            Util.getIntValue(workflowid), isForce1, isUpgrade1, map);

                    rs.writeLog("requestid:" + requestid + "执行完毕<br/>");
                    if (!result.isEmpty()) {
                        rs.writeLog("do action on kqtype 失败:" + result + "<br/>");
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }


            }
        }

    }

}
