package weaver.interfaces.hansang.job;


import com.engine.kq.biz.KQHolidaySetBiz;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.time.LocalTime;
import java.time.format.DateTimeFormatter;

/**
 * @author wanxq
 * @date 2023年08月17日14:17:51
 * @desc 处理加班跨天情况考勤日历打卡数据异常问题
 */
public class OvertimeSignCalculateJob extends BaseCronJob {

    @Override
    public void execute() {

        RecordSet rs = new RecordSet();
        RecordSet rs2 = new RecordSet();

        //DepartmentComInfo deptComInfo = new DepartmentComInfo();
        //ArrayList allChildDept = new ArrayList();
        //allChildDept.add("44");
        //allChildDept.add("77");
        //deptComInfo.getAllChildDeptByDepId(allChildDept,"44");
        //deptComInfo.getAllChildDeptByDepId(allChildDept,"77");
        //String deptids = StringUtils.join(allChildDept, ",");


        String currentMonth = DateUtil.getCurrentDate().substring(0,7);
        int timescope = Util.getIntValue(rs.getPropValue("cus_kq_conf","scope"),2);


        String sql = " select resourceId,fromDate,fromTime ,toDate ,toTime ,departmentId " +
                " from formtable_main_75 " +
                " where fromDate like '"+currentMonth+"%'  " +
                " and datediff(toDate,fromDate)=1 " +
                " union " +
                " select jbry,ksrq,kssj,jsrq,jssj,szbm " +
                " from formtable_main_76 a,formtable_main_76_dt1 b " +
                " where a.id=b.mainid and ksrq like '"+currentMonth+"%'  " +
                " and datediff(jsrq,ksrq)=1 ";
        rs.executeQuery(sql);
        while(rs.next()){
            String resourceId = Util.null2String(rs.getString("resourceId"));
            String fromDate = Util.null2String(rs.getString("fromDate"));
            String fromTime = Util.null2String(rs.getString("fromTime"));
            String toDate = Util.null2String(rs.getString("toDate"));
            String toTime = Util.null2String(rs.getString("toTime"));

            boolean isHoliday = false;
            int changeType = KQHolidaySetBiz.getChangeType("2",fromDate);
            if (changeType != 2 && (DateUtil.getWeek(fromDate) == 6 || DateUtil.getWeek(fromDate) == 7)) {
                isHoliday = true;
            }
            if (changeType == 1 || changeType == 3) {
                isHoliday = true;
            }

            if(isHoliday){
                //计算上班打卡时间
                String startTime = minusHour(fromTime,timescope);
                String endTime = addHour(fromTime,timescope);
                String signinTime = getSigninTime(resourceId,fromDate,startTime,endTime);

                //计算下班打卡时间
                startTime = minusHour(toTime,2);
                endTime = addHour(toTime,2);
                String signoutTime = getSignoutTime(resourceId,toDate,startTime,endTime);

                String updateSql = " update kq_format_detail set signindate=?,signintime=?, signoutdate=?,signouttime=? where kqdate=? ";
                rs2.executeUpdate(updateSql,fromDate,signinTime,toDate,signoutTime,fromDate);

            }

        }

    }


    /**
     * 获取上班打卡时间
     * @param userid
     * @param signdate
     * @param startTime
     * @param endTime
     * @return
     */
    public String getSigninTime(String userid,String signdate,String startTime,String endTime){
        String signtime = "";
        RecordSet rs = new RecordSet();
        String sql = " select min(signtime) signtime from hrmschedulesign " +
                "where userid=? and signdate=? and signtime>=? and signtime<=? ";
        rs.executeQuery(sql,userid,signdate,startTime,endTime);
        if(rs.next()){
            signtime = Util.null2String(rs.getString("signtime"));
        }
        return signtime;
    }


    /**
     * 获取下班打卡时间
     * @param userid
     * @param signdate
     * @param startTime
     * @param endTime
     * @return
     */
    public String getSignoutTime(String userid,String signdate,String startTime,String endTime){
        String signtime = "";
        RecordSet rs = new RecordSet();
        String sql = " select max(signtime) signtime from hrmschedulesign " +
                "where userid=? and signdate=? and signtime>=? and signtime<=? ";
        rs.executeQuery(sql,userid,signdate,startTime,endTime);
        if(rs.next()){
            signtime = Util.null2String(rs.getString("signtime"));
        }
        return signtime;
    }


    /**
     * 时间加
     * @param time
     * @param hour
     * @return
     */
    public String addHour(String time,long hour){
        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("HH:mm");
        LocalTime localTime = LocalTime.parse(time,dtf).plusHours(hour);
        return localTime.toString();
    }

    /**
     * 时间减
     * @param time
     * @param hour
     * @return
     */
    public String minusHour(String time,long hour){
        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("HH:mm");
        LocalTime localTime = LocalTime.parse(time,dtf).minusHours(hour);
        return localTime.toString();
    }


}
