package weaver.interfaces.hansang.job;


import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * @author wanxq
 * @date 2023年09月19日09:44:44
 * @desc 自动更新人员卡片信息
 */
public class UserCardInfoUpdateJob extends BaseCronJob {


    @Override
    public void execute() {
        RecordSet rs = new RecordSet();

        //更新成本中心、成本中心名称
        String cbzxsql = " update cus_fielddata a, hrmresource b,hrmdepartmentdefined c set a.field117 = c.cbbmdmcw,a.field118=c.cbbmcw " +
                " where a.id = b.id and b.departmentid=c.deptid and a.scopeid=3 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3  " +
                " and (a.field117 is null or a.field117='' or a.field118 is null or a.field118='') ";
        rs.executeUpdate(cbzxsql);

        //更新人员卡片中文名字段
        String xmsql = " update cus_fielddata a, hrmresource b " +
                " set a.field116 = substr(b.lastname,instr(b.lastname,'-')+1) " +
                " where a.id = b.id and a.scopeid=-1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field116 is null or a.field116='') ";
        rs.executeUpdate(xmsql);

        //更新员工角色 根据直间接刷新:办公月结人员、办公非月结人员为Default，制造人员为制造人员，劳务人员为劳务人员
        String jssql = " update cus_fielddata a, hrmresource b set a.field37 = case when field35<=1 then 0 when  field35=2 then 2 when field35=3 then 4 else null end " +
                " where a.id = b.id and a.scopeid=-1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field37 is null or a.field37='') ";
        rs.executeUpdate(jssql);

        //更新是否打卡，默认是
        String dksql = " update cus_fielddata a, hrmresource b set a.field112 = 0 " +
                " where a.id = b.id and a.scopeid=3 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field112 is null or a.field112='') ";
        rs.executeUpdate(dksql);

        //更新参加工作日期：默认入职日期
        String workSql = " update hrmresource set workstartdate=companystartdate where status<=3 and (workstartdate is null or workstartdate='') ";
        rs.executeUpdate(workSql);

        //更新试用期结束日期、转正日期：非办公默认入职日期加一个自然月
        String syqSql = " update cus_fielddata a, hrmresource b,cus_fielddata c set b.probationenddate = date_add(date_add(b.companystartdate,INTERVAL 1 MONTH), INTERVAL -1 DAY) " +
                " where a.id = b.id and a.id=c.id and a.scopeid=3 and a.scope='hrmcustomfieldbyinfotype' " +
                " and (a.field82>date_add(b.companystartdate,INTERVAL 1 MONTH) or a.field82 is null or a.field82='') "+
                " and c.field35 in(2,3,4)  and (b.probationenddate is null or b.probationenddate='') ";
        rs.executeUpdate(syqSql);

        //String zzrqSql = " update cus_fielddata a, hrmresource b,cus_fielddata c set a.field18 = date_add(b.companystartdate,INTERVAL 1 MONTH) " +
        //        " where a.id = b.id and a.id=c.id and a.scopeid=3 and a.scope='hrmcustomfieldbyinfotype' " +
        //        " and (a.field82>date_add(b.companystartdate,INTERVAL 1 MONTH) or a.field82 is null or a.field82='') "+
        //        " and c.field35 in(2,3,4)  and (a.field18 is null or a.field18='') ";
        //rs.executeUpdate(zzrqSql);

        //更新社保缴纳地 默认:南京
        String sbsql = " update cus_fielddata a, hrmresource b set a.field114 = 1 " +
                " where a.id = b.id and a.scopeid=1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field114 is null or a.field114='') ";
        rs.executeUpdate(sbsql);

        //更新公积金缴纳地 默认:南京
        String gjjsql =  " update cus_fielddata a, hrmresource b set a.field115 = 2 " +
                " where a.id = b.id and a.scopeid=1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field115 is null or a.field115='') ";
        rs.executeUpdate(gjjsql);

        //更新薪资岗位：根据岗位同步
        String xzgwsql = " update cus_fielddata a, hrmresource b set a.field72 = b.jobtitle " +
                "where a.id = b.id and a.scopeid=1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 and (a.field72 is nul or a.field72='') ";
        rs.executeUpdate(xzgwsql);

        //更新人员年龄
        String ageSql = " update cus_fielddata a, hrmresource b set a.field136= floor(datediff(now(), birthday)/365) " +
                "where a.id = b.id and a.scopeid=1 and a.scope='hrmcustomfieldbyinfotype' and b.status<=3 ";
        rs.executeUpdate(ageSql);

        //更新个税扣缴义务人
        //当直/间接等于制造人员、劳务人员、临时工时且个税扣缴义务人为空时，个税扣缴义务人更新为：4:（非办公）汉桑（南京）科技股份有限公司
        String kjywrSql = " update cus_fielddata set field137=4 where scopeid=-1 and field35 in(2,3,4) and (field137='' or field137 is null) ";
        rs.executeUpdate(kjywrSql);

        //更新薪资等级
//        String xzdjsql =  "update cus_fielddata a, hrmresource b,cus_fielddata c set a.field67 = 3\n" +
//                "        where a.id = b.id and a.id = c.id and a.scopeid=1 and a.scope='hrmcustomfieldbyinfotype'\n" +
//                " and b.status<=3  and c.field35 in(2,3,4) and (a.field67 is null or a.field67='')";
//        rs.executeUpdate(xzdjsql);
    }





}
