package weaver.interfaces.hskq.action;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ServiceUtil;
import com.engine.kq.biz.KQReportBiz;
import com.engine.kq.service.KQReportService;
import com.engine.kq.service.impl.KQReportServiceImpl;
import weaver.common.DateUtil;
import weaver.conn.BatchRecordSet;
import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.interfaces.schedule.BaseCronJob;
import weaver.join.hrm.in.HrmResource;
import weaver.systeminfo.SystemEnv;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created with IntelliJ IDEA.
 * 考勤每月汇总信息生成
 * @Auther: chenxu
 * @Date: 2024/05/28/14:03
 * @Description:
 */
public class KqBaseInfoCreateEveryDay extends BaseCronJob {

    static String dateFormat = "yyyy-MM-dd";
    static SimpleDateFormat format = new SimpleDateFormat(dateFormat);

    private KQReportService getService(User user) {
        return (KQReportService) ServiceUtil.getService(KQReportServiceImpl.class, user);
    }

    @Override
    public void execute() {
        new BaseBean();
        BaseBean bb = new BaseBean();
        RecordSet rs = new RecordSet();
        bb.writeLog("考勤每月汇总信息生成！！！");
        String fromDate = TimeUtil.getDateByOption("3", "0");
        String toDate = fromDate.substring(0,7)+"-31";
        try {
            Map<String, Object> apidatas = new HashMap<String, Object>();
            User userLcc = new User(1);
            Map<String, Object> params = new HashMap<String, Object>();
            params.put("reportType","month");
            Map<String, Object> paramsData = new HashMap<String, Object>();
            paramsData.put("pageIndex",0);
            paramsData.put("typeselect","3");
            paramsData.put("viewScope","0");
            paramsData.put("status","9");
            paramsData.put("isNoAccount","1");
            paramsData.put("attendanceSerial","");
            params.put("data",JSONObject.toJSONString(paramsData));
            apidatas = getService(userLcc).getKQReport(params, userLcc);
//            bb.writeLog("apidatas:"+JSONObject.toJSONString(apidatas));
            JSONArray jsonArray = JSON.parseArray(Util.null2String(JSONObject.toJSONString(apidatas.get("datas"))));
            bb.writeLog("jsonArray:"+JSONObject.toJSONString(jsonArray));
            for (Iterator<Object> iterator = jsonArray.iterator(); iterator.hasNext(); ) {
                List<List<Object>> lsParams = new ArrayList<>();
                List<List<Object>> lsDelParams = new ArrayList<>();
                JSONObject next = (JSONObject) iterator.next();
                //人员id
                String resourceId = next.getString("resourceId");
                //编号
                String workcode = next.getString("workcode");
                //岗位
                String jobtitleId = next.getString("jobtitleId");
                //部门编码
                String deptcode = next.getString("deptcode");
                //上级部门
                String supdept = next.getString("supdept");
                //部门
                String departmentId = next.getString("departmentId");
                //新增属性
                String ofr08name = next.getString("ofr08name");
                //直\间接
                String ofr07name = next.getString("ofr07name");
                //应出勤天数
                String workdays = next.getString("workdays");
                //应工作时长
                String workmins = next.getString("workmins");
                //实际出勤天数
                String attendancedays = next.getString("attendancedays");
                //实际工作时长
                String attendanceMins = next.getString("attendanceMins");
                //迟到次数
                String beLate = next.getString("beLate");
                //迟到时长
                String beLateMins = next.getString("beLateMins");
                //严重迟到
                String graveBeLate = next.getString("graveBeLate");
                //严重迟到时长
                String graveBeLateMins = next.getString("graveBeLateMins");
                //早退
                String leaveEearly = next.getString("leaveEearly");
                //早退时长
                String leaveEarlyMins = next.getString("leaveEarlyMins");
                //严重早退
                String graveLeaveEarly =  next.getString("graveLeaveEarly");
                //严重早退时长
                String graveLeaveEarlyMins = next.getString("graveLeaveEarlyMins");
                //缺勤
                String absenteeism = next.getString("absenteeism");
                //缺勤时长
                String absenteeismMins = next.getString("absenteeismMins");
                //漏签
                String forgotCheck = next.getString("forgotCheck");
                //午餐次数
                String wucancishu = next.getString("wucancishu");
                //晚餐次数
                String jiabancishu = next.getString("jiabancishu");
                //午餐次数含夜班
                String jiabancishuYb = next.getString("jiabancishuYb");
                //晚餐次数含夜班
                String wucancishuYb = next.getString("wucancishuYb");
                //夜班次数
                String ybcs = next.getString("ybcs");
                //法定年假
                String fdnj = next.getString("leaveType_-6");
                //带薪病假
                String dxbj = next.getString("leaveType_4");
                //调休平时加班
                String txpsjb = next.getString("leaveType_5");
                //产假
                String cj = next.getString("leaveType_8");
                //陪产假
                String pcj = next.getString("leaveType_9");
                //福利年假
                String flnj = next.getString("leaveType_13");
                //小产假
                String xcj = next.getString("leaveType_14");
                //产检假
                String cjj = next.getString("leaveType_15");
                //调休周末加班
                String txzmjb = next.getString("leaveType_16");
                //产假刨妇产顺延
                String cjpfc = next.getString("leaveType_17");
                //产假多胞胎顺延
                String cjdbtsy = next.getString("leaveType_18");
                //三八节福利假
                String sbjflj = next.getString("leaveType_19");
                //特殊公出
                String tsgc = next.getString("leaveType_20");
                //放工假
                String fgj = next.getString("leaveType_21");
                //工伤假
                String gsj = next.getString("leaveType_22");
                //事假
                String sj = next.getString("leaveType_26");
                //病假
                String bj = next.getString("leaveType_27");
                //婚假
                String hj = next.getString("leaveType_32");
                //哺乳假
                String brj = next.getString("leaveType_34");
                //丧假
                String sangj = next.getString("leaveType_35");
                //育儿假
                String yrj = next.getString("leaveType_36");
                //独生子女护理假
                String dsznhlj = next.getString("leaveType_37");
                //工作日加班不关联调休
                String gzrjbno = next.getString("workingDayOvertime_nonleave");
                //工作日加班关联调休
                String gzrjb = next.getString("workingDayOvertime_4leave");
                //休息日加班不关联调休
                String xxrjbno = next.getString("restDayOvertime_nonleave");
                //休息日加班关联调休
                String xxrjb = next.getString("restDayOvertime_4leave");
                //节假日加班不关联调休
                String jjrjbno = next.getString("holidayOvertime_nonleave");
                //节假日加班关联调休
                String jjrjb = next.getString("holidayOvertime_4leave");
                //加班汇总
                String jbhz = next.getString("overtimeTotal");
                //出差
                String cc = next.getString("businessLeave");
                //公出
                String gc = next.getString("officialBusiness");


                bb.writeLog("userId:"+resourceId+"workdays:"+workdays);
                KQReportBiz kqReportBiz = new KQReportBiz();
                Map<String, Object> detialDatas = kqReportBiz.getDetialDatasOnlyTime(resourceId, fromDate, toDate, userLcc);
                Map<String, Object> detialOvtimeDatas = kqReportBiz.getDetialOvtimeData(resourceId, fromDate, toDate);
                List<Object> data = new ArrayList<>();
                String today = DateUtil.getCurrentDate();
                bb.writeLog("detialDatas:"+JSONObject.toJSONString(detialDatas)+"detialOvtimeDatas:"+JSONObject.toJSONString(detialOvtimeDatas));
                List<String> all = new ArrayList<>();
                all.add(fromDate);
                List<String> back = days(fromDate,toDate);
                all.addAll(back);
                all.add(toDate);
                for(String date:all){
                    if (DateUtil.compDate(today, date) > 0) {
                        data.add("");
                    } else {
                        if (detialDatas.get(resourceId + "|" + date) != null) {
                            double atttime = Util.getDoubleValue((String) detialDatas.get(resourceId + "|" + date),0);
                            bb.writeLog("date:"+date+"atttime:"+atttime);
                            if(detialOvtimeDatas.get(resourceId + "|" + date) !=null ){
                                atttime += (double) detialOvtimeDatas.get(resourceId + "|" + date);
                                bb.writeLog("atttimeNew:"+atttime);
                            }
                            data.add(atttime);
                        } else {
                            data.add(SystemEnv.getHtmlLabelName(26593, userLcc.getLanguage()));
                        }
                    }
                }
                bb.writeLog("dataText:"+JSONObject.toJSONString(data));
                List<Object> par = new ArrayList<>();
                List<Object> parDel = new ArrayList<>();
                par.add(resourceId);
                par.add(workcode);
                par.add(jobtitleId);
                par.add(deptcode);
                par.add(supdept);
                par.add(departmentId);
                par.add(ofr08name);
                par.add(ofr07name);
                par.add(workdays);
                par.add(workmins);
                par.add(attendancedays);
                par.add(attendanceMins);
                par.add(beLate);
                par.add(beLateMins);
                par.add(graveBeLate);
                par.add(graveBeLateMins);
                par.add(leaveEearly);
                par.add(leaveEarlyMins);
                par.add(graveLeaveEarly);
                par.add(graveLeaveEarlyMins);
                par.add(absenteeism);
                par.add(absenteeismMins);
                par.add(forgotCheck);
                par.add(wucancishu);
                par.add(jiabancishu);
                par.add(jiabancishuYb);
                par.add(wucancishuYb);
                par.add(ybcs);
                par.add(fdnj);
                par.add(dxbj);
                par.add(txpsjb);
                par.add(cj);
                par.add(pcj);
                par.add(flnj);
                par.add(xcj);
                par.add(cjj);
                par.add(txzmjb);
                par.add(cjpfc);
                par.add(cjdbtsy);
                par.add(sbjflj);
                par.add(tsgc);
                par.add(fgj);
                par.add(gsj);
                par.add(sj);
                par.add(bj);
                par.add(hj);
                par.add(brj);
                par.add(sangj);
                par.add(yrj);
                par.add(dsznhlj);
                par.add(gzrjbno);
                par.add(xxrjbno);
                par.add(jjrjbno);
                par.add(gzrjb);
                par.add(xxrjb);
                par.add(jjrjb);
                par.add(jbhz);
                par.add(cc);
                par.add(gc);
                //年月
                String ny = fromDate.substring(0,7);
                par.add(ny);
                //入职日期
                String rzrq = findRzrq(resourceId);
                //转正日期
                String zzrq = getField18(resourceId);
                //离职日期
                String lzrq = getField82(resourceId);
                par.add(rzrq);
                par.add(zzrq);
                par.add(lzrq);
                //人员状态
                String ryzt = getStatus(resourceId);
                par.add(ryzt);
                //考勤月
                String kqy = ny+"-01";
                par.add(kqy);
                //日历
                for (int i = 0; i < all.size(); i++) {
                    par.add(data.get(i));
                }


                parDel.add(resourceId);
                parDel.add(ny);
                lsDelParams.add(parDel);

                BatchRecordSet bRs = new BatchRecordSet();
                bb.writeLog("开始同步数据");
                bb.writeLog("lsDelParams:"+JSON.toJSONString(lsDelParams));

                String sql = "";
                //删除本次同步数据
                sql = " delete from uf_kqhzbx where xm = ? and ny = ?";
                bRs.executeBatchSql(sql, lsDelParams);

                int modeid = getFormModeIdByCubeName("uf_kqhzbx");
                SimpleDateFormat sdfDate = new SimpleDateFormat("yyyy-MM-dd");
                SimpleDateFormat sdfTime = new SimpleDateFormat("HH:mm:ss");
                String modedatacreatedate = sdfDate.format(new java.util.Date());
                String modedatacreatetime = sdfTime.format(new Date());

                par.add(modeid);
                par.add(resourceId);
                par.add("0");
                par.add(modedatacreatedate);
                par.add(modedatacreatetime);
                lsParams.add(par);

                sql = " insert into uf_kqhzbx (xm, bh, gw, bmbm, sjbm, bm, xzzx, zjj, ycqtst, ygzscxs, " +
                        "sjcqtst,sjgzscxs,cdc,cdscxs,yzcdc,yzcdscxs,ztc,ztscxs,yzztc,yzztscxs," +
                        "qqc,qqscxs,lqc,wuccsc,wanccsc,wuccshybc,wanccshybc,ybcsc,fdnjxs,flnjxs," +
                        "sjxs,dxbjt,bjt,hjt,sjt,xcjt,cjjt,pcjt,dxpsjbxs,dxzmjbxs," +
                        "brjxs,cjt,cjpfcsyt,cjdbtsyt,sbjfljt,tsgct,fgjxs,gsjt,yejt,dsznhljt," +
                        "bgldxgzrjbxs,bgldxxxrjbxs,bgldxjjrjbxs,gldxgzrjbxs,gldxxxrjbxs,gldxjjrjbxs,jbzjxs,cct,gcxs," +
                        "ny,rzrq,zzrq,lzrq,ryzt,kqy,h1,h2,h3,h4,h5,h6," +
                        "h7,h8,h9,h10,h11,h12,h13,h14,h15,h16," +
                        "h17,h18,h19,h20,h21,h22,h23,h24,h25,h26," +
                        "h27,h28,h29,h30,h31,FORMMODEID,MODEDATACREATER,MODEDATACREATERTYPE,MODEDATACREATEDATE,MODEDATACREATETIME) "
                        + " values(?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?," +
                        "?,?,?,?,?,?,?,?,?,?)";
                bRs.executeBatchSql(sql,lsParams);

                String idNew = "";
                RecordSet findNew = new RecordSet();
                String sqlFindnew ="select Id from uf_kqhzbx where xm = "+resourceId+" and ny = '"+ny+"'  order by" +
                        " modedatacreatedate desc,modedatacreatetime desc";
                findNew.execute(sqlFindnew);
                bb.writeLog("findSqlNew:"+sqlFindnew);
                if (findNew.next()){
                    idNew = weaver.general.Util.null2String(findNew.getString("id"));
                }
                bb.writeLog("idNew:"+idNew);
                // 权限重构
                int dataId = Integer.valueOf(idNew);
                ModeRightInfo modeRightInfo = new ModeRightInfo();
                modeRightInfo.editModeDataShare(Integer.valueOf(resourceId), modeid, dataId);
            }

        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("新入职员工当天打卡数据生成--error"+e.getMessage());
        }
    }


    /**
     * 根据建模表名获取formModeId
     *
     * @param cubeName 建模表明
     * @return int formModeId
     */
    private static int getFormModeIdByCubeName(String cubeName) {
        RecordSet rs = new RecordSet();
        rs.executeQuery("select t1.id from modeinfo t1\n" +
                " left join workflow_bill t2\n" +
                " on t1.formid=t2.id\n" +
                " where t2.tablename='" + cubeName + "'");
        rs.next();
        return rs.getInt("id");
    }

    /**
     * 找到人员入职日期
     *
     * @return
     */
    public static String findRzrq(String jbr) {
        RecordSet rs = new RecordSet();
        String sql = "select id,companystartdate from hrmresource where id ="+jbr;
        rs.executeQuery(sql);
        String companystartdate = "";
        if (rs.next()) {
            companystartdate = Util.null2String(rs.getString("companystartdate"));
        }
        return companystartdate;
    }

    /**
     * 获取转正日期
     * @param userid
     * @return
     */
    private static String getField18(String userid){
        RecordSet rs = new RecordSet();
        String sql = "select field18 from cus_fielddata where id = "+userid+" and scope = 'HrmCustomFieldByInfoType' and scopeid = 3";
        rs.executeQuery(sql);
        String 	field18 = "";
        if (rs.next()){
            field18 = Util.null2String(rs.getString("field18"));
        }
        return field18;
    }

    /**
     * 获取离职日期
     * @param userid
     * @return
     */
    private static String getField82(String userid){
        RecordSet rs = new RecordSet();
        String sql = "select field82 from cus_fielddata where id = "+userid+" and scope = 'HrmCustomFieldByInfoType' and scopeid = 3";
        rs.executeQuery(sql);
        String 	field82 = "";
        if (rs.next()){
            field82 = Util.null2String(rs.getString("field82"));
        }
        return field82;
    }

    /**
     * 获取人员状态
     * @param userid
     * @return
     */
    private static String getStatus(String userid){
        RecordSet rs = new RecordSet();
        String sql = "select status from hrmresource where  id = "+userid;
        rs.executeQuery(sql);
        String 	status = "";
        if (rs.next()){
            status = Util.null2String(rs.getString("status"));
        }
        return status;
    }


    public static void main(String[] args) {
        String fromDate = TimeUtil.getDateByOption("3", "0");
        String toDate = fromDate.substring(0,7)+"-31";
        Map<String, Object> detialDatas = new HashMap<>();
        Map<String, Object> detialOvtimeDatas = new HashMap<>();
        detialDatas.put("432|2024-06-02","0.0");
        detialDatas.put("432|2024-06-01","0.0");
        boolean isEnd = false;
        List<Object> data = new ArrayList<>();
        String today = DateUtil.getCurrentDate();
        Calendar cal = DateUtil.getCalendar();
        List<String> all = new ArrayList<>();
        all.add(fromDate);
        List<String> back = days(fromDate,toDate);
        all.addAll(back);
        all.add(toDate);
        for(String date:all){
            if (DateUtil.compDate(today, date) > 0) {
                data.add("");
            } else {
                if (detialDatas.get("432" + "|" + date) != null) {
                    double atttime = Util.getDoubleValue((String) detialDatas.get("432" + "|" + date),0);
                    if(detialOvtimeDatas.get("432" + "|" + date) !=null ){
                        atttime += (double) detialOvtimeDatas.get("432" + "|" + date);
                    }
                    data.add(atttime);
                } else {
                    data.add("other");
                }
            }
        }
        System.out.println("dataText:"+JSONObject.toJSONString(data));
        List<Object> par = new ArrayList<>();
        for (int i = 0; i < all.size(); i++) {
            par.add(data.get(i));
        }
        System.out.println(par.toString());



    }

    /**
     * 获取两个日期之间所有的日期
     * @param date1
     * @param date2
     * @return
     */
    public static ArrayList days(String date1, String date2) {
        ArrayList L = new ArrayList();
        if (date1.equals(date2)) {
            System.out.println("两个日期相等!");
            return L;
        }

        String tmp;
        if (date1.compareTo(date2) > 0) { // 确保 date1的日期不晚于date2
            tmp = date1;
            date1 = date2;
            date2 = tmp;
        }

        tmp = format.format(str2Date(date1).getTime() + 3600 * 24 * 1000);

        int num = 0;
        while (tmp.compareTo(date2) < 0) {
            L.add(tmp);
            num++;
            tmp = format.format(str2Date(tmp).getTime() + 3600 * 24 * 1000);
        }

        if (num == 0)
            System.out.println("两个日期相邻!");
        return L;
    }

    private static Date str2Date(String str) {
        if (str == null)
            return null;

        try {
            return format.parse(str);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

}
