package weaver.interfaces.leshanvc.cronjob;

import com.weaver.general.Util;
import org.apache.commons.collections.CollectionUtils;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.ArrayList;
import java.util.List;

/**
 * 同步任职资格定时任务
 *
 * @author:dxfeng
 * @createTime: 2023/02/10
 * @version: 1.0
 */
public class SyncQualificationsJob extends BaseCronJob {
    /**
     * 当前时间
     */
    private static final String CURRENT_DATE = DateUtil.getCurrentDate();

    @Override
    public void execute() {
        RecordSet rs = new RecordSet();
        List<Qualification> qualificationList = new ArrayList<>();
        String sql;
        // 查询“认证时间”大于等于“当前日期”的数据
        sql = "select rzsj,ry,zzrdj,zzrdd from uf_rzzg where rzsj >='" + CURRENT_DATE + "'";
        rs.execute(sql);
        while (rs.next()) {
            qualificationList.add(new Qualification(rs.getString("ry"), rs.getString("zzrdj"), rs.getString("zzrdd")));
        }
        // 同步浏览按钮数据
        if (CollectionUtils.isNotEmpty(qualificationList)) {
            for (Qualification qualification : qualificationList) {
                sql = "update cus_fielddata set field94 = '" + Util.null2String(qualification.getLevelId()) + "',field95 ='" + Util.null2String(qualification.getGradeId()) + "' where scope ='HrmCustomFieldByInfoType' and scopeid ='3' and id = '" + qualification.getUserId() + "'";
                rs.executeUpdate(sql);
            }
        }
    }

    static class Qualification {
        // 人员ID
        private final String userId;
        // 职级ID
        private final String gradeId;
        // 职等ID
        private final String levelId;

        Qualification(String userId, String gradeId, String levelId) {
            this.userId = userId;
            this.gradeId = gradeId;
            this.levelId = levelId;
        }

        public String getUserId() {
            return userId;
        }

        public String getGradeId() {
            return gradeId;
        }

        public String getLevelId() {
            return levelId;
        }
    }
}
