package weaver.interfaces.leshanvc.formmode;

import com.alibaba.fastjson.JSONObject;
import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author ml
 * @Date 2023/3/14 18:09
 * @Description 登记提交保存按钮
 * @Since version-1.0
 */
public class RegisterSaveExpand extends AbstractModeExpandJavaCodeNew {
    /**
     * hrmresource表，离职状态
     */
    private static final String RESIGN_STATUS = "5";

    /**
     * 执行模块扩展动作
     * @param param
     *  param包含(但不限于)以下数据
     *  user 当前用户
     *  importtype 导入方式(仅在批量导入的接口动作会传输) 1 追加，2覆盖,3更新，获取方式(int)param.get("importtype")
     *  导入链接中拼接的特殊参数(仅在批量导入的接口动作会传输)，比如a=1，可通过param.get("a")获取参数值
     *  页面链接拼接的参数，比如b=2,可以通过param.get("b")来获取参数
     * @return
     */
    public Map<String, String> doModeExpand(Map<String, Object> param) {
        Map<String, String> result = new HashMap<String, String>();
        try {
            User user = (User)param.get("user");
            int billid = -1;//数据id
            int modeid = -1;//模块id
            RequestInfo requestInfo = (RequestInfo)param.get("RequestInfo");
            if(requestInfo!=null){
                billid = Util.getIntValue(requestInfo.getRequestid());
                modeid = Util.getIntValue(requestInfo.getWorkflowid());
                if(billid>0&&modeid>0){
                    //------请在下面编写业务逻辑代码------
                    RecordSet rs = new RecordSet();
                    //JSON转换,获取离职管理表中
                    String JSONStr = (String) param.get("JSONStr");
                    JSONObject jsonObject = (JSONObject) JSONObject.parse(JSONStr);
                    // 申请人
                    String sqr = jsonObject.getString(queryField(rs,"sqr"));
                    // 计划离职日期
                    String jhlzrq = jsonObject.getString(queryField(rs,"jhlzrq"));
                    // 确定离职日期
                    String qdlzrq = jsonObject.getString(queryField(rs,"qdlzrq"));
                    // 离职原因
                    String lzyyxz = jsonObject.getString(queryField(rs,"lzyyxz"));

                    // 更新人员卡片自定义字段
                    rs.executeUpdate("update cus_fielddata set field31 = ?, field82 = ?, field50 = ? where scope ='HrmCustomFieldByInfoType' and scopeid ='3' and id = ? ", jhlzrq, qdlzrq, lzyyxz, sqr);

                    // 更新人员为离职状态
                    rs.executeUpdate("update hrmresource set status = ? where id = ? ", RESIGN_STATUS, sqr);
                }
            }
        } catch (Exception e) {
            result.put("errmsg","自定义出错信息");
            result.put("flag", "false");
        }
        return result;
    }

    /**
     * 查询表单对应字段
     */
    private String queryField(RecordSet rs,String fieldName) {
        rs.executeQuery("select b.id from workflow_bill a \n" +
                "INNER JOIN workflow_billfield b on a.id=b.billid\n" +
                "where a.tablename='uf_lzgl' and b.fieldname='" + fieldName + "'");
        String field = "field";
        if (rs.next()) {
            field += rs.getString("id");
        }
        return field;
    }
}
