package weaver.interfaces.leshanvc.workflow.action;

import com.engine.kq.log.KQLog;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.leshanvc.workflow.util.ConvertDurationUtil;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;


/**
 * @author:dxfeng
 * @createTime: 2023/02/17
 * @version: 1.0
 */
public class OutSplitAction extends BaseBean implements Action {
    private KQLog kqLog = new KQLog();

    @Override
    public String execute(RequestInfo request) {
        String requestid = request.getRequestid();
        int requestidInt = Util.getIntValue(requestid, 0);


        try {
            RecordSet rs = new RecordSet();
            String sql = "select * from kq_flow_split_out where requestid = ? ";
            rs.executeQuery(sql, requestidInt);
            if (rs.next()) {
                String durationrule = rs.getString("durationrule");
                if ("3".equals(durationrule)) {
                    String duration = rs.getString("duration");
                    String halfHour = ConvertDurationUtil.handelHalfHour(duration);
                    rs.executeUpdate("update kq_flow_split_out set duration = ? where requestid =?", halfHour, requestidInt);
                }
            }
        } catch (Exception e) {
            request.getRequestManager().setMessageid("11111" + request.getRequestid() + "22222");
            request.getRequestManager().setMessagecontent("【公出流程action】报错，请联系管理员！");
            return Action.FAILURE_AND_CONTINUE;
        }

        return Action.SUCCESS;

    }

}
