package weaver.interfaces.leshanvc.workflow.action;

import weaver.conn.RecordSet;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2023/2/21
 * @Version V1.0
 **/
public class ShuttleRouteSyncAction implements Action{

    private String fieldName;

    private String scope;

    private String scopeId;

    @Override
    public String execute(RequestInfo requestInfo) {
        RecordSet rs = new RecordSet();
        String tableName = requestInfo.getRequestManager().getBillTableName();
        String requestId = requestInfo.getRequestid();

        rs.executeQuery("select sqr,bclx from " + tableName + " where requestid = ?", requestId);
        rs.next();
        int sqr = Util.getIntValue(rs.getString("sqr"));
        int bclx = Util.getIntValue(rs.getString("bclx"));

        rs.executeUpdate("update cus_fielddata set "+fieldName+"=? where scope = ? and scopeid = ? and id = ?",
                bclx, scope,scopeId,sqr);

        return SUCCESS;
    }

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public String getScope() {
        return scope;
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public String getScopeId() {
        return scopeId;
    }

    public void setScopeId(String scopeId) {
        this.scopeId = scopeId;
    }
}
