package weaver.interfaces.leshanvc.workflow.action;

import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @Author ml
 * @Date 2023/4/3 9:45
 * @Description 转正申请（非办公）办结时，更新人员状态、转正日期
 * @Since version-1.0
 */
public class UpdateStatusAfterRegularAction implements Action {
    BaseBean baseBean = new BaseBean();

    @Override
    public String execute(RequestInfo requestInfo) {
        baseBean.writeLog("转正申请（非办公）办结更新人员状态action");
        RecordSet rs = new RecordSet();
        String tableName = requestInfo.getRequestManager().getBillTableName();
        String requestId = requestInfo.getRequestid();

        String updateHrmResource = "update hrmresource set status=1 where id=?";
        String updateCusFieldData = "update cus_fielddata set field18=? where scope='HrmCustomFieldByInfoType' and scopeid='3' and id=?";

        String zzr = null;
        String zzrq = null;
        try {
            rs.executeQuery("select zzr,zzrq from "+tableName+" where requestid=?",requestId);
            if (rs.next()) {
                zzr = Util.null2String(rs.getString("zzr"));
                zzrq = Util.null2String(rs.getString("zzrq"));
            }
            if (StringUtils.isNotBlank(zzr)) {
                rs.executeUpdate(updateHrmResource,zzr);
                rs.executeUpdate(updateCusFieldData,zzrq,zzr);
            }
        } catch (Exception e) {
            baseBean.writeLog(e);
            requestInfo.getRequestManager().setMessageid("错误流程requestID" + requestInfo.getRequestid());
            requestInfo.getRequestManager().setMessagecontent("【转正申请(非办公)办结action】报错，请联系管理员！");
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }
}
